// A Bison parser, made by GNU Bison 3.5.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2019 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// Undocumented macros, especially those whose name start with YY_,
// are private implementation details.  Do not rely on them.



// First part of user prologue.
#line 1 "parse/thrifty.yy"

/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements. See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership. The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License. You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

/**
 * Thrift parser.
 *
 * This parser is used on a thrift definition file.
 *
 */

#define __STDC_LIMIT_MACROS
#define __STDC_FORMAT_MACROS

#include <cassert>
#include <stdio.h>
#include <inttypes.h>
#include <limits.h>
#include <stack>
#include <utility>

#include <boost/optional.hpp>

#include <thrift/compiler/ast/base_types.h>
#include <thrift/compiler/ast/t_annotated.h>
#include <thrift/compiler/ast/t_scope.h>
#include <thrift/compiler/ast/t_union.h>
#include <thrift/compiler/parse/parsing_driver.h>
#include <thrift/compiler/ast/t_container.h>
/**
 * Note macro expansion because this is different between OSS and internal
 * build, sigh.
 */
#include THRIFTY_HH

/**
 * Declare fbthrift_compiler_parse_lex() so we can use it.
 */
YY_DECL;
#define yylex fbthrift_compiler_parse_lex

namespace apache {
namespace thrift {
namespace compiler {
namespace {

/**
 * This global variable is used for automatic numbering of field indices etc.
 * when parsing the members of a struct. Field values are automatically
 * assigned starting from -1 and working their way down.
 */
int y_field_val = -1;

/**
 * This global variable is used for automatic numbering of enum values.
 * y_enum_val is the last value assigned; the next auto-assigned value will be
 * y_enum_val+1, and then it continues working upwards.  Explicitly specified
 * enum values reset y_enum_val to that value.
 */
int32_t y_enum_val = -1;
int g_arglist = 0;
const char* y_enum_name = nullptr;

// Assume ownership of a pointer.
template <typename T>
std::unique_ptr<T> own(T* ptr) {
  return std::unique_ptr<T>(ptr);
}

// Return the value being pointed to as a temporary and deletes the given pointer.
template<typename T>
T consume(T* ptr) {
  assert(ptr != nullptr);
  T result(std::move(*ptr));
  delete ptr;
  return result;
}

} // namespace
} // namespace compiler
} // namespace thrift
} // namespace apache


#line 141 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"


#include "thrifty.hh"




#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif



// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yystack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YYUSE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 120 "parse/thrifty.yy"
namespace apache { namespace thrift { namespace compiler { namespace yy {
#line 219 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"


  /// Build a parser object.
  parser::parser (apache::thrift::compiler::parsing_driver& driver_yyarg, yyscan_t raw_scanner_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      driver (driver_yyarg),
      raw_scanner (raw_scanner_yyarg)
  {}

  parser::~parser ()
  {}

  parser::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------------.
  | Symbol types.  |
  `---------------*/



  // by_state.
  parser::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

  parser::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
  parser::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
  parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  parser::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

  parser::symbol_number_type
  parser::by_state::type_get () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return empty_symbol;
    else
      return yystos_[state];
  }

  parser::stack_symbol_type::stack_symbol_type ()
  {}

  parser::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state))
  {
    switch (that.type_get ())
    {
      case 77: // CommaOrSemicolonOptional
        value.YY_MOVE_OR_COPY< bool > (YY_MOVE (that.value));
        break;

      case 9: // tok_dub_constant
        value.YY_MOVE_OR_COPY< double > (YY_MOVE (that.value));
        break;

      case 7: // tok_bool_constant
      case 8: // tok_int_constant
        value.YY_MOVE_OR_COPY< int64_t > (YY_MOVE (that.value));
        break;

      case 3: // tok_identifier
      case 4: // tok_literal
      case 6: // tok_st_identifier
      case 66: // Identifier
      case 144: // IntOrLiteral
        value.YY_MOVE_OR_COPY< std::string > (YY_MOVE (that.value));
        break;

      case 139: // TypeAnnotation
        value.YY_MOVE_OR_COPY< t_annotation* > (YY_MOVE (that.value));
        break;

      case 136: // TypeAnnotations
      case 138: // TypeAnnotationList
      case 143: // FunctionAnnotations
        value.YY_MOVE_OR_COPY< t_annotations* > (YY_MOVE (that.value));
        break;

      case 84: // Const
      case 142: // StructuredAnnotation
        value.YY_MOVE_OR_COPY< t_const* > (YY_MOVE (that.value));
        break;

      case 86: // ConstValue
      case 87: // ConstList
      case 88: // ConstListContents
      case 89: // ConstMap
      case 90: // ConstMapContents
      case 91: // ConstStruct
      case 93: // ConstStructContents
      case 123: // FieldValue
        value.YY_MOVE_OR_COPY< t_const_value* > (YY_MOVE (that.value));
        break;

      case 132: // ContainerType
      case 133: // MapType
      case 134: // SetType
      case 135: // ListType
        value.YY_MOVE_OR_COPY< t_container* > (YY_MOVE (that.value));
        break;

      case 5: // tok_doctext
      case 67: // CaptureDocText
        value.YY_MOVE_OR_COPY< t_doc > (YY_MOVE (that.value));
        break;

      case 78: // Enum
      case 81: // EnumDefList
        value.YY_MOVE_OR_COPY< t_enum* > (YY_MOVE (that.value));
        break;

      case 82: // EnumDef
      case 83: // EnumValue
        value.YY_MOVE_OR_COPY< t_enum_value* > (YY_MOVE (that.value));
        break;

      case 102: // ErrorBlame
        value.YY_MOVE_OR_COPY< t_error_blame > (YY_MOVE (that.value));
        break;

      case 101: // ErrorKind
        value.YY_MOVE_OR_COPY< t_error_kind > (YY_MOVE (that.value));
        break;

      case 100: // ErrorSafety
        value.YY_MOVE_OR_COPY< t_error_safety > (YY_MOVE (that.value));
        break;

      case 98: // Xception
        value.YY_MOVE_OR_COPY< t_exception* > (YY_MOVE (that.value));
        break;

      case 114: // Param
      case 119: // Field
        value.YY_MOVE_OR_COPY< t_field* > (YY_MOVE (that.value));
        break;

      case 122: // FieldRequiredness
        value.YY_MOVE_OR_COPY< t_field::e_req > (YY_MOVE (that.value));
        break;

      case 121: // FieldIdentifier
        value.YY_MOVE_OR_COPY< t_field_id > (YY_MOVE (that.value));
        break;

      case 118: // FieldList
        value.YY_MOVE_OR_COPY< t_field_list* > (YY_MOVE (that.value));
        break;

      case 111: // Function
        value.YY_MOVE_OR_COPY< t_function* > (YY_MOVE (that.value));
        break;

      case 115: // FunctionQualifier
        value.YY_MOVE_OR_COPY< t_function_qualifier > (YY_MOVE (that.value));
        break;

      case 112: // ParamList
      case 113: // EmptyParamList
        value.YY_MOVE_OR_COPY< t_paramlist* > (YY_MOVE (that.value));
        break;

      case 131: // BaseType
        value.YY_MOVE_OR_COPY< t_ref<t_base_type> > (YY_MOVE (that.value));
        break;

      case 73: // Definition
        value.YY_MOVE_OR_COPY< t_ref<t_node> > (YY_MOVE (that.value));
        break;

      case 103: // Service
      case 107: // Extends
      case 108: // Interaction
      case 110: // FunctionList
        value.YY_MOVE_OR_COPY< t_service* > (YY_MOVE (that.value));
        break;

      case 127: // ResponseAndSinkReturnType
      case 128: // SinkReturnType
        value.YY_MOVE_OR_COPY< t_sink* > (YY_MOVE (that.value));
        break;

      case 125: // ResponseAndStreamReturnType
      case 126: // StreamReturnType
        value.YY_MOVE_OR_COPY< t_stream_response* > (YY_MOVE (that.value));
        break;

      case 94: // Struct
      case 116: // Throws
      case 117: // MaybeThrows
        value.YY_MOVE_OR_COPY< t_struct* > (YY_MOVE (that.value));
        break;

      case 140: // StructuredAnnotations
      case 141: // NonEmptyStructuredAnnotationList
        value.YY_MOVE_OR_COPY< t_struct_annotations* > (YY_MOVE (that.value));
        break;

      case 92: // ConstStructType
      case 124: // FunctionType
      case 130: // FieldType
        value.YY_MOVE_OR_COPY< t_type_ref* > (YY_MOVE (that.value));
        break;

      case 74: // Typedef
        value.YY_MOVE_OR_COPY< t_typedef* > (YY_MOVE (that.value));
        break;

      case 129: // SinkFieldType
        value.YY_MOVE_OR_COPY< t_typestructpair > (YY_MOVE (that.value));
        break;

      case 96: // Union
        value.YY_MOVE_OR_COPY< t_union* > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

  parser::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s)
  {
    switch (that.type_get ())
    {
      case 77: // CommaOrSemicolonOptional
        value.move< bool > (YY_MOVE (that.value));
        break;

      case 9: // tok_dub_constant
        value.move< double > (YY_MOVE (that.value));
        break;

      case 7: // tok_bool_constant
      case 8: // tok_int_constant
        value.move< int64_t > (YY_MOVE (that.value));
        break;

      case 3: // tok_identifier
      case 4: // tok_literal
      case 6: // tok_st_identifier
      case 66: // Identifier
      case 144: // IntOrLiteral
        value.move< std::string > (YY_MOVE (that.value));
        break;

      case 139: // TypeAnnotation
        value.move< t_annotation* > (YY_MOVE (that.value));
        break;

      case 136: // TypeAnnotations
      case 138: // TypeAnnotationList
      case 143: // FunctionAnnotations
        value.move< t_annotations* > (YY_MOVE (that.value));
        break;

      case 84: // Const
      case 142: // StructuredAnnotation
        value.move< t_const* > (YY_MOVE (that.value));
        break;

      case 86: // ConstValue
      case 87: // ConstList
      case 88: // ConstListContents
      case 89: // ConstMap
      case 90: // ConstMapContents
      case 91: // ConstStruct
      case 93: // ConstStructContents
      case 123: // FieldValue
        value.move< t_const_value* > (YY_MOVE (that.value));
        break;

      case 132: // ContainerType
      case 133: // MapType
      case 134: // SetType
      case 135: // ListType
        value.move< t_container* > (YY_MOVE (that.value));
        break;

      case 5: // tok_doctext
      case 67: // CaptureDocText
        value.move< t_doc > (YY_MOVE (that.value));
        break;

      case 78: // Enum
      case 81: // EnumDefList
        value.move< t_enum* > (YY_MOVE (that.value));
        break;

      case 82: // EnumDef
      case 83: // EnumValue
        value.move< t_enum_value* > (YY_MOVE (that.value));
        break;

      case 102: // ErrorBlame
        value.move< t_error_blame > (YY_MOVE (that.value));
        break;

      case 101: // ErrorKind
        value.move< t_error_kind > (YY_MOVE (that.value));
        break;

      case 100: // ErrorSafety
        value.move< t_error_safety > (YY_MOVE (that.value));
        break;

      case 98: // Xception
        value.move< t_exception* > (YY_MOVE (that.value));
        break;

      case 114: // Param
      case 119: // Field
        value.move< t_field* > (YY_MOVE (that.value));
        break;

      case 122: // FieldRequiredness
        value.move< t_field::e_req > (YY_MOVE (that.value));
        break;

      case 121: // FieldIdentifier
        value.move< t_field_id > (YY_MOVE (that.value));
        break;

      case 118: // FieldList
        value.move< t_field_list* > (YY_MOVE (that.value));
        break;

      case 111: // Function
        value.move< t_function* > (YY_MOVE (that.value));
        break;

      case 115: // FunctionQualifier
        value.move< t_function_qualifier > (YY_MOVE (that.value));
        break;

      case 112: // ParamList
      case 113: // EmptyParamList
        value.move< t_paramlist* > (YY_MOVE (that.value));
        break;

      case 131: // BaseType
        value.move< t_ref<t_base_type> > (YY_MOVE (that.value));
        break;

      case 73: // Definition
        value.move< t_ref<t_node> > (YY_MOVE (that.value));
        break;

      case 103: // Service
      case 107: // Extends
      case 108: // Interaction
      case 110: // FunctionList
        value.move< t_service* > (YY_MOVE (that.value));
        break;

      case 127: // ResponseAndSinkReturnType
      case 128: // SinkReturnType
        value.move< t_sink* > (YY_MOVE (that.value));
        break;

      case 125: // ResponseAndStreamReturnType
      case 126: // StreamReturnType
        value.move< t_stream_response* > (YY_MOVE (that.value));
        break;

      case 94: // Struct
      case 116: // Throws
      case 117: // MaybeThrows
        value.move< t_struct* > (YY_MOVE (that.value));
        break;

      case 140: // StructuredAnnotations
      case 141: // NonEmptyStructuredAnnotationList
        value.move< t_struct_annotations* > (YY_MOVE (that.value));
        break;

      case 92: // ConstStructType
      case 124: // FunctionType
      case 130: // FieldType
        value.move< t_type_ref* > (YY_MOVE (that.value));
        break;

      case 74: // Typedef
        value.move< t_typedef* > (YY_MOVE (that.value));
        break;

      case 129: // SinkFieldType
        value.move< t_typestructpair > (YY_MOVE (that.value));
        break;

      case 96: // Union
        value.move< t_union* > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

    // that is emptied.
    that.type = empty_symbol;
  }

#if YY_CPLUSPLUS < 201103L
  parser::stack_symbol_type&
  parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    switch (that.type_get ())
    {
      case 77: // CommaOrSemicolonOptional
        value.copy< bool > (that.value);
        break;

      case 9: // tok_dub_constant
        value.copy< double > (that.value);
        break;

      case 7: // tok_bool_constant
      case 8: // tok_int_constant
        value.copy< int64_t > (that.value);
        break;

      case 3: // tok_identifier
      case 4: // tok_literal
      case 6: // tok_st_identifier
      case 66: // Identifier
      case 144: // IntOrLiteral
        value.copy< std::string > (that.value);
        break;

      case 139: // TypeAnnotation
        value.copy< t_annotation* > (that.value);
        break;

      case 136: // TypeAnnotations
      case 138: // TypeAnnotationList
      case 143: // FunctionAnnotations
        value.copy< t_annotations* > (that.value);
        break;

      case 84: // Const
      case 142: // StructuredAnnotation
        value.copy< t_const* > (that.value);
        break;

      case 86: // ConstValue
      case 87: // ConstList
      case 88: // ConstListContents
      case 89: // ConstMap
      case 90: // ConstMapContents
      case 91: // ConstStruct
      case 93: // ConstStructContents
      case 123: // FieldValue
        value.copy< t_const_value* > (that.value);
        break;

      case 132: // ContainerType
      case 133: // MapType
      case 134: // SetType
      case 135: // ListType
        value.copy< t_container* > (that.value);
        break;

      case 5: // tok_doctext
      case 67: // CaptureDocText
        value.copy< t_doc > (that.value);
        break;

      case 78: // Enum
      case 81: // EnumDefList
        value.copy< t_enum* > (that.value);
        break;

      case 82: // EnumDef
      case 83: // EnumValue
        value.copy< t_enum_value* > (that.value);
        break;

      case 102: // ErrorBlame
        value.copy< t_error_blame > (that.value);
        break;

      case 101: // ErrorKind
        value.copy< t_error_kind > (that.value);
        break;

      case 100: // ErrorSafety
        value.copy< t_error_safety > (that.value);
        break;

      case 98: // Xception
        value.copy< t_exception* > (that.value);
        break;

      case 114: // Param
      case 119: // Field
        value.copy< t_field* > (that.value);
        break;

      case 122: // FieldRequiredness
        value.copy< t_field::e_req > (that.value);
        break;

      case 121: // FieldIdentifier
        value.copy< t_field_id > (that.value);
        break;

      case 118: // FieldList
        value.copy< t_field_list* > (that.value);
        break;

      case 111: // Function
        value.copy< t_function* > (that.value);
        break;

      case 115: // FunctionQualifier
        value.copy< t_function_qualifier > (that.value);
        break;

      case 112: // ParamList
      case 113: // EmptyParamList
        value.copy< t_paramlist* > (that.value);
        break;

      case 131: // BaseType
        value.copy< t_ref<t_base_type> > (that.value);
        break;

      case 73: // Definition
        value.copy< t_ref<t_node> > (that.value);
        break;

      case 103: // Service
      case 107: // Extends
      case 108: // Interaction
      case 110: // FunctionList
        value.copy< t_service* > (that.value);
        break;

      case 127: // ResponseAndSinkReturnType
      case 128: // SinkReturnType
        value.copy< t_sink* > (that.value);
        break;

      case 125: // ResponseAndStreamReturnType
      case 126: // StreamReturnType
        value.copy< t_stream_response* > (that.value);
        break;

      case 94: // Struct
      case 116: // Throws
      case 117: // MaybeThrows
        value.copy< t_struct* > (that.value);
        break;

      case 140: // StructuredAnnotations
      case 141: // NonEmptyStructuredAnnotationList
        value.copy< t_struct_annotations* > (that.value);
        break;

      case 92: // ConstStructType
      case 124: // FunctionType
      case 130: // FieldType
        value.copy< t_type_ref* > (that.value);
        break;

      case 74: // Typedef
        value.copy< t_typedef* > (that.value);
        break;

      case 129: // SinkFieldType
        value.copy< t_typestructpair > (that.value);
        break;

      case 96: // Union
        value.copy< t_union* > (that.value);
        break;

      default:
        break;
    }

    return *this;
  }

  parser::stack_symbol_type&
  parser::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    switch (that.type_get ())
    {
      case 77: // CommaOrSemicolonOptional
        value.move< bool > (that.value);
        break;

      case 9: // tok_dub_constant
        value.move< double > (that.value);
        break;

      case 7: // tok_bool_constant
      case 8: // tok_int_constant
        value.move< int64_t > (that.value);
        break;

      case 3: // tok_identifier
      case 4: // tok_literal
      case 6: // tok_st_identifier
      case 66: // Identifier
      case 144: // IntOrLiteral
        value.move< std::string > (that.value);
        break;

      case 139: // TypeAnnotation
        value.move< t_annotation* > (that.value);
        break;

      case 136: // TypeAnnotations
      case 138: // TypeAnnotationList
      case 143: // FunctionAnnotations
        value.move< t_annotations* > (that.value);
        break;

      case 84: // Const
      case 142: // StructuredAnnotation
        value.move< t_const* > (that.value);
        break;

      case 86: // ConstValue
      case 87: // ConstList
      case 88: // ConstListContents
      case 89: // ConstMap
      case 90: // ConstMapContents
      case 91: // ConstStruct
      case 93: // ConstStructContents
      case 123: // FieldValue
        value.move< t_const_value* > (that.value);
        break;

      case 132: // ContainerType
      case 133: // MapType
      case 134: // SetType
      case 135: // ListType
        value.move< t_container* > (that.value);
        break;

      case 5: // tok_doctext
      case 67: // CaptureDocText
        value.move< t_doc > (that.value);
        break;

      case 78: // Enum
      case 81: // EnumDefList
        value.move< t_enum* > (that.value);
        break;

      case 82: // EnumDef
      case 83: // EnumValue
        value.move< t_enum_value* > (that.value);
        break;

      case 102: // ErrorBlame
        value.move< t_error_blame > (that.value);
        break;

      case 101: // ErrorKind
        value.move< t_error_kind > (that.value);
        break;

      case 100: // ErrorSafety
        value.move< t_error_safety > (that.value);
        break;

      case 98: // Xception
        value.move< t_exception* > (that.value);
        break;

      case 114: // Param
      case 119: // Field
        value.move< t_field* > (that.value);
        break;

      case 122: // FieldRequiredness
        value.move< t_field::e_req > (that.value);
        break;

      case 121: // FieldIdentifier
        value.move< t_field_id > (that.value);
        break;

      case 118: // FieldList
        value.move< t_field_list* > (that.value);
        break;

      case 111: // Function
        value.move< t_function* > (that.value);
        break;

      case 115: // FunctionQualifier
        value.move< t_function_qualifier > (that.value);
        break;

      case 112: // ParamList
      case 113: // EmptyParamList
        value.move< t_paramlist* > (that.value);
        break;

      case 131: // BaseType
        value.move< t_ref<t_base_type> > (that.value);
        break;

      case 73: // Definition
        value.move< t_ref<t_node> > (that.value);
        break;

      case 103: // Service
      case 107: // Extends
      case 108: // Interaction
      case 110: // FunctionList
        value.move< t_service* > (that.value);
        break;

      case 127: // ResponseAndSinkReturnType
      case 128: // SinkReturnType
        value.move< t_sink* > (that.value);
        break;

      case 125: // ResponseAndStreamReturnType
      case 126: // StreamReturnType
        value.move< t_stream_response* > (that.value);
        break;

      case 94: // Struct
      case 116: // Throws
      case 117: // MaybeThrows
        value.move< t_struct* > (that.value);
        break;

      case 140: // StructuredAnnotations
      case 141: // NonEmptyStructuredAnnotationList
        value.move< t_struct_annotations* > (that.value);
        break;

      case 92: // ConstStructType
      case 124: // FunctionType
      case 130: // FieldType
        value.move< t_type_ref* > (that.value);
        break;

      case 74: // Typedef
        value.move< t_typedef* > (that.value);
        break;

      case 129: // SinkFieldType
        value.move< t_typestructpair > (that.value);
        break;

      case 96: // Union
        value.move< t_union* > (that.value);
        break;

      default:
        break;
    }

    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
  parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
  parser::yy_print_ (std::ostream& yyo,
                                     const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YYUSE (yyoutput);
    symbol_number_type yytype = yysym.type_get ();
#if defined __GNUC__ && ! defined __clang__ && ! defined __ICC && __GNUC__ * 100 + __GNUC_MINOR__ <= 408
    // Avoid a (spurious) G++ 4.8 warning about "array subscript is
    // below array bounds".
    if (yysym.empty ())
      std::abort ();
#endif
    yyo << (yytype < yyntokens_ ? "token" : "nterm")
        << ' ' << yytname_[yytype] << " (";
    YYUSE (yytype);
    yyo << ')';
  }
#endif

  void
  parser::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
  parser::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
  parser::yypop_ (int n)
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  parser::debug_level_type
  parser::debug_level () const
  {
    return yydebug_;
  }

  void
  parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  parser::state_type
  parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - yyntokens_] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - yyntokens_];
  }

  bool
  parser::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  bool
  parser::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
  parser::operator() ()
  {
    return parse ();
  }

  int
  parser::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token: ";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            symbol_type yylookahead (yylex (driver, raw_scanner));
            yyla.move (yylookahead);
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.type_get ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.type_get ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", static_cast<state_type> (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
      switch (yyr1_[yyn])
    {
      case 77: // CommaOrSemicolonOptional
        yylhs.value.emplace< bool > ();
        break;

      case 9: // tok_dub_constant
        yylhs.value.emplace< double > ();
        break;

      case 7: // tok_bool_constant
      case 8: // tok_int_constant
        yylhs.value.emplace< int64_t > ();
        break;

      case 3: // tok_identifier
      case 4: // tok_literal
      case 6: // tok_st_identifier
      case 66: // Identifier
      case 144: // IntOrLiteral
        yylhs.value.emplace< std::string > ();
        break;

      case 139: // TypeAnnotation
        yylhs.value.emplace< t_annotation* > ();
        break;

      case 136: // TypeAnnotations
      case 138: // TypeAnnotationList
      case 143: // FunctionAnnotations
        yylhs.value.emplace< t_annotations* > ();
        break;

      case 84: // Const
      case 142: // StructuredAnnotation
        yylhs.value.emplace< t_const* > ();
        break;

      case 86: // ConstValue
      case 87: // ConstList
      case 88: // ConstListContents
      case 89: // ConstMap
      case 90: // ConstMapContents
      case 91: // ConstStruct
      case 93: // ConstStructContents
      case 123: // FieldValue
        yylhs.value.emplace< t_const_value* > ();
        break;

      case 132: // ContainerType
      case 133: // MapType
      case 134: // SetType
      case 135: // ListType
        yylhs.value.emplace< t_container* > ();
        break;

      case 5: // tok_doctext
      case 67: // CaptureDocText
        yylhs.value.emplace< t_doc > ();
        break;

      case 78: // Enum
      case 81: // EnumDefList
        yylhs.value.emplace< t_enum* > ();
        break;

      case 82: // EnumDef
      case 83: // EnumValue
        yylhs.value.emplace< t_enum_value* > ();
        break;

      case 102: // ErrorBlame
        yylhs.value.emplace< t_error_blame > ();
        break;

      case 101: // ErrorKind
        yylhs.value.emplace< t_error_kind > ();
        break;

      case 100: // ErrorSafety
        yylhs.value.emplace< t_error_safety > ();
        break;

      case 98: // Xception
        yylhs.value.emplace< t_exception* > ();
        break;

      case 114: // Param
      case 119: // Field
        yylhs.value.emplace< t_field* > ();
        break;

      case 122: // FieldRequiredness
        yylhs.value.emplace< t_field::e_req > ();
        break;

      case 121: // FieldIdentifier
        yylhs.value.emplace< t_field_id > ();
        break;

      case 118: // FieldList
        yylhs.value.emplace< t_field_list* > ();
        break;

      case 111: // Function
        yylhs.value.emplace< t_function* > ();
        break;

      case 115: // FunctionQualifier
        yylhs.value.emplace< t_function_qualifier > ();
        break;

      case 112: // ParamList
      case 113: // EmptyParamList
        yylhs.value.emplace< t_paramlist* > ();
        break;

      case 131: // BaseType
        yylhs.value.emplace< t_ref<t_base_type> > ();
        break;

      case 73: // Definition
        yylhs.value.emplace< t_ref<t_node> > ();
        break;

      case 103: // Service
      case 107: // Extends
      case 108: // Interaction
      case 110: // FunctionList
        yylhs.value.emplace< t_service* > ();
        break;

      case 127: // ResponseAndSinkReturnType
      case 128: // SinkReturnType
        yylhs.value.emplace< t_sink* > ();
        break;

      case 125: // ResponseAndStreamReturnType
      case 126: // StreamReturnType
        yylhs.value.emplace< t_stream_response* > ();
        break;

      case 94: // Struct
      case 116: // Throws
      case 117: // MaybeThrows
        yylhs.value.emplace< t_struct* > ();
        break;

      case 140: // StructuredAnnotations
      case 141: // NonEmptyStructuredAnnotationList
        yylhs.value.emplace< t_struct_annotations* > ();
        break;

      case 92: // ConstStructType
      case 124: // FunctionType
      case 130: // FieldType
        yylhs.value.emplace< t_type_ref* > ();
        break;

      case 74: // Typedef
        yylhs.value.emplace< t_typedef* > ();
        break;

      case 129: // SinkFieldType
        yylhs.value.emplace< t_typestructpair > ();
        break;

      case 96: // Union
        yylhs.value.emplace< t_union* > ();
        break;

      default:
        break;
    }



      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 2:
#line 321 "parse/thrifty.yy"
    {
      driver.debug("Program -> Headers DefinitionList");
      /*
      TODO(dreiss): Decide whether full-program doctext is worth the trouble.
      if ($1) {
        driver.program->set_doc($1);
      }
      */
      driver.clear_doctext();
    }
#line 1448 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 3:
#line 334 "parse/thrifty.yy"
    {
      yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > ();
    }
#line 1456 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 4:
#line 339 "parse/thrifty.yy"
    {
      yylhs.value.as < std::string > () = "sink";
    }
#line 1464 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 5:
#line 343 "parse/thrifty.yy"
    {
      yylhs.value.as < std::string > () = "oneway";
    }
#line 1472 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 6:
#line 347 "parse/thrifty.yy"
    {
      yylhs.value.as < std::string > () = "readonly";
    }
#line 1480 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 7:
#line 351 "parse/thrifty.yy"
    {
      yylhs.value.as < std::string > () = "idempotent";
    }
#line 1488 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 8:
#line 355 "parse/thrifty.yy"
    {
      yylhs.value.as < std::string > () = "safe";
    }
#line 1496 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 9:
#line 359 "parse/thrifty.yy"
    {
      yylhs.value.as < std::string > () = "transient";
    }
#line 1504 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 10:
#line 363 "parse/thrifty.yy"
    {
      yylhs.value.as < std::string > () = "stateful";
    }
#line 1512 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 11:
#line 367 "parse/thrifty.yy"
    {
      yylhs.value.as < std::string > () = "permanent";
    }
#line 1520 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 12:
#line 371 "parse/thrifty.yy"
    {
      yylhs.value.as < std::string > () = "server";
    }
#line 1528 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 13:
#line 375 "parse/thrifty.yy"
    {
      yylhs.value.as < std::string > () = "client";
    }
#line 1536 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 14:
#line 381 "parse/thrifty.yy"
    {
      if (driver.mode == parsing_mode::PROGRAM) {
        yylhs.value.as < t_doc > () = driver.doctext;
        driver.doctext = boost::none;
      } else {
        yylhs.value.as < t_doc > () = boost::none;
      }
    }
#line 1549 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 15:
#line 392 "parse/thrifty.yy"
    {
      if (driver.mode == parsing_mode::PROGRAM) {
        driver.clear_doctext();
      }
    }
#line 1559 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 16:
#line 402 "parse/thrifty.yy"
    {
      driver.debug("HeaderList -> HeaderList Header");
    }
#line 1567 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 17:
#line 406 "parse/thrifty.yy"
    {
      driver.debug("HeaderList -> ");
    }
#line 1575 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 18:
#line 412 "parse/thrifty.yy"
    {
      driver.debug("Header -> Include");
    }
#line 1583 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 19:
#line 416 "parse/thrifty.yy"
    {
      driver.debug("Header -> tok_namespace Identifier Identifier");
      if (driver.mode == parsing_mode::PROGRAM) {
        driver.program->set_namespace(yystack_[1].value.as < std::string > (), yystack_[0].value.as < std::string > ());
      }
    }
#line 1594 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 20:
#line 423 "parse/thrifty.yy"
    {
      driver.debug("Header -> tok_namespace Identifier tok_literal");
      if (driver.mode == parsing_mode::PROGRAM) {
        driver.program->set_namespace(yystack_[1].value.as < std::string > (), yystack_[0].value.as < std::string > ());
      }
    }
#line 1605 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 21:
#line 430 "parse/thrifty.yy"
    {
      driver.debug("Header -> tok_cpp_include tok_literal");
      if (driver.mode == parsing_mode::PROGRAM) {
        driver.program->add_cpp_include(yystack_[0].value.as < std::string > ());
      }
    }
#line 1616 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 22:
#line 437 "parse/thrifty.yy"
    {
      driver.debug("Header -> tok_hs_include tok_literal");
      // Do nothing. This syntax is handled by the hs compiler
    }
#line 1625 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 23:
#line 444 "parse/thrifty.yy"
    {
      driver.debug("Include -> tok_include tok_literal");
      if (driver.mode == parsing_mode::INCLUDES) {
        std::string path = driver.include_file(std::string(yystack_[0].value.as < std::string > ()));
        if (!path.empty()) {
          if (driver.program_cache.find(path) == driver.program_cache.end()) {
            auto included_program = driver.program->add_include(path, std::string(yystack_[0].value.as < std::string > ()), driver.scanner->get_lineno());
            driver.program_cache[path] = included_program.get();
            driver.program_bundle->add_program(std::move(included_program));
          } else {
            auto include = std::make_unique<t_include>(driver.program_cache[path]);
            include->set_lineno(driver.scanner->get_lineno());
            driver.program->add_include(std::move(include));
          }
        }
      }
    }
#line 1647 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 24:
#line 464 "parse/thrifty.yy"
    {
      driver.debug("DefinitionList -> DefinitionList Definition");
    }
#line 1655 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 25:
#line 468 "parse/thrifty.yy"
    {
      driver.debug("DefinitionList -> ");
    }
#line 1663 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 26:
#line 474 "parse/thrifty.yy"
    {
      driver.debug("Definition -> Const");
      yylhs.value.as < t_ref<t_node> > () = driver.add_decl(own(yystack_[0].value.as < t_const* > ()), std::move(yystack_[1].value.as < t_doc > ()));
    }
#line 1672 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 27:
#line 479 "parse/thrifty.yy"
    {
      driver.debug("Definition -> Typedef");
      yylhs.value.as < t_ref<t_node> > () = driver.add_decl(own(yystack_[0].value.as < t_typedef* > ()), std::move(yystack_[1].value.as < t_doc > ()));
    }
#line 1681 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 28:
#line 484 "parse/thrifty.yy"
    {
      driver.debug("Definition -> Enum");
      yylhs.value.as < t_ref<t_node> > () = driver.add_decl(own(yystack_[0].value.as < t_enum* > ()), std::move(yystack_[1].value.as < t_doc > ()));
    }
#line 1690 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 29:
#line 489 "parse/thrifty.yy"
    {
      driver.debug("Definition -> Struct");
      yylhs.value.as < t_ref<t_node> > () = driver.add_decl(own(yystack_[0].value.as < t_struct* > ()), std::move(yystack_[1].value.as < t_doc > ()));
    }
#line 1699 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 30:
#line 494 "parse/thrifty.yy"
    {
      driver.debug("Definition -> Union");
      yylhs.value.as < t_ref<t_node> > () = driver.add_decl(own(yystack_[0].value.as < t_union* > ()), std::move(yystack_[1].value.as < t_doc > ()));
    }
#line 1708 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 31:
#line 499 "parse/thrifty.yy"
    {
      driver.debug("Definition -> Xception");
      yylhs.value.as < t_ref<t_node> > () = driver.add_decl(own(yystack_[0].value.as < t_exception* > ()), std::move(yystack_[1].value.as < t_doc > ()));
    }
#line 1717 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 32:
#line 504 "parse/thrifty.yy"
    {
      driver.debug("Definition -> Service");
      yylhs.value.as < t_ref<t_node> > () = driver.add_decl(own(yystack_[0].value.as < t_service* > ()), std::move(yystack_[1].value.as < t_doc > ()));
    }
#line 1726 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 33:
#line 509 "parse/thrifty.yy"
    {
      driver.debug("Definition -> Interaction");
      yylhs.value.as < t_ref<t_node> > () = driver.add_decl(own(yystack_[0].value.as < t_service* > ()), std::move(yystack_[1].value.as < t_doc > ()));
    }
#line 1735 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 34:
#line 516 "parse/thrifty.yy"
    {
      driver.start_node(LineType::Typedef);
    }
#line 1743 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 35:
#line 520 "parse/thrifty.yy"
    {
      driver.debug("TypeDef => StructuredAnnotations tok_typedef FieldType "
          "Identifier TypeAnnotations");
      yylhs.value.as < t_typedef* > () = new t_typedef(driver.program, consume(yystack_[2].value.as < t_type_ref* > ()), std::move(yystack_[1].value.as < std::string > ()), driver.scope_cache);
      driver.finish_node(yylhs.value.as < t_typedef* > (), LineType::Typedef, own(yystack_[0].value.as < t_annotations* > ()), own(yystack_[5].value.as < t_struct_annotations* > ()));
    }
#line 1754 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 36:
#line 529 "parse/thrifty.yy"
    {}
#line 1760 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 37:
#line 531 "parse/thrifty.yy"
    {}
#line 1766 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 38:
#line 535 "parse/thrifty.yy"
    {
      yylhs.value.as < bool > () = true;
    }
#line 1774 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 39:
#line 539 "parse/thrifty.yy"
    {
      yylhs.value.as < bool > () = false;
    }
#line 1782 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 40:
#line 545 "parse/thrifty.yy"
    {
      driver.start_node(LineType::Enum);
    }
#line 1790 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 41:
#line 549 "parse/thrifty.yy"
    {
      assert(!y_enum_name);
      y_enum_name = yystack_[0].value.as < std::string > ().c_str();
    }
#line 1799 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 42:
#line 554 "parse/thrifty.yy"
    {
      driver.debug("Enum => StructuredAnnotations tok_enum Identifier { EnumDefList } TypeAnnotations");
      driver.finish_node(yystack_[2].value.as < t_enum* > (), LineType::Enum, yystack_[5].value.as < std::string > (), own(yystack_[0].value.as < t_annotations* > ()), own(yystack_[8].value.as < t_struct_annotations* > ()));
      yylhs.value.as < t_enum* > () = yystack_[2].value.as < t_enum* > ();
      y_enum_name = nullptr;
    }
#line 1810 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 43:
#line 563 "parse/thrifty.yy"
    {
      driver.debug("EnumDefList -> EnumDefList EnumDef");
      yylhs.value.as < t_enum* > () = yystack_[1].value.as < t_enum* > ();

      if (driver.mode == parsing_mode::PROGRAM) {
        auto const_val = std::make_unique<t_const_value>(yystack_[0].value.as < t_enum_value* > ()->get_value());

        const_val->set_is_enum();
        const_val->set_enum(yylhs.value.as < t_enum* > ());
        const_val->set_enum_value(yystack_[0].value.as < t_enum_value* > ());

        auto tconst = std::make_unique<t_const>(
            driver.program, &t_base_type::t_i32(), yystack_[0].value.as < t_enum_value* > ()->get_name(), std::move(const_val));

        assert(y_enum_name != nullptr);
        std::string type_prefix = std::string(y_enum_name) + ".";
        driver.scope_cache->add_constant(
            driver.program->name() + "." + yystack_[0].value.as < t_enum_value* > ()->get_name(), tconst.get());
        driver.scope_cache->add_constant(
            driver.program->name() + "." + type_prefix + yystack_[0].value.as < t_enum_value* > ()->get_name(), tconst.get());

        yylhs.value.as < t_enum* > ()->append(own(yystack_[0].value.as < t_enum_value* > ()), std::move(tconst));
      } else {
        driver.delete_at_the_end(yystack_[0].value.as < t_enum_value* > ());
      }
    }
#line 1841 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 44:
#line 590 "parse/thrifty.yy"
    {
      driver.debug("EnumDefList -> ");
      yylhs.value.as < t_enum* > () = new t_enum(driver.program);
      y_enum_val = -1;
    }
#line 1851 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 45:
#line 598 "parse/thrifty.yy"
    {
      driver.debug("EnumDef => CaptureDocText StructuredAnnotations EnumValue "
        "TypeAnnotations CommaOrSemicolonOptional");
      yylhs.value.as < t_enum_value* > () = yystack_[2].value.as < t_enum_value* > ();
      if (yystack_[4].value.as < t_doc > ()) {
        yylhs.value.as < t_enum_value* > ()->set_doc(std::move(*yystack_[4].value.as < t_doc > ()));
      }
      driver.set_annotations(yylhs.value.as < t_enum_value* > (), own(yystack_[1].value.as < t_annotations* > ()), own(yystack_[3].value.as < t_struct_annotations* > ()));
    }
#line 1865 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 46:
#line 610 "parse/thrifty.yy"
    {
      driver.debug("EnumValue -> Identifier = tok_int_constant");
      if (yystack_[0].value.as < int64_t > () < 0 && !driver.params.allow_neg_enum_vals) {
        driver.warning(1, "Negative value supplied for enum %s.", yystack_[2].value.as < std::string > ().c_str());
      }
      if (yystack_[0].value.as < int64_t > () < INT32_MIN || yystack_[0].value.as < int64_t > () > INT32_MAX) {
        // Note: this used to be just a warning.  However, since thrift always
        // treats enums as i32 values, I'm changing it to a fatal error.
        // I doubt this will affect many people, but users who run into this
        // will have to update their thrift files to manually specify the
        // truncated i32 value that thrift has always been using anyway.
        driver.failure("64-bit value supplied for enum %s will be truncated.", yystack_[2].value.as < std::string > ().c_str());
      }
      y_enum_val = yystack_[0].value.as < int64_t > ();
      yylhs.value.as < t_enum_value* > () = new t_enum_value;
      yylhs.value.as < t_enum_value* > ()->set_name(yystack_[2].value.as < std::string > ());
      yylhs.value.as < t_enum_value* > ()->set_value(y_enum_val);
      yylhs.value.as < t_enum_value* > ()->set_lineno(driver.scanner->get_lineno());
    }
#line 1889 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 47:
#line 631 "parse/thrifty.yy"
    {
      driver.debug("EnumValue -> Identifier");
      if (y_enum_val == INT32_MAX) {
        driver.failure("enum value overflow at enum %s", yystack_[0].value.as < std::string > ().c_str());
      }
      yylhs.value.as < t_enum_value* > () = new t_enum_value;
      yylhs.value.as < t_enum_value* > ()->set_name(yystack_[0].value.as < std::string > ());
      yylhs.value.as < t_enum_value* > ()->set_implicit_value(++y_enum_val);
      yylhs.value.as < t_enum_value* > ()->set_lineno(driver.scanner->get_lineno());
    }
#line 1904 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 48:
#line 644 "parse/thrifty.yy"
    {
      driver.start_node(LineType::Const);
    }
#line 1912 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 49:
#line 648 "parse/thrifty.yy"
    {
      driver.debug("StructuredAnnotations Const => tok_const FieldType Identifier = ConstValue");
      if (driver.mode == parsing_mode::PROGRAM) {
        yylhs.value.as < t_const* > () = new t_const(driver.program, consume(yystack_[5].value.as < t_type_ref* > ()), std::move(yystack_[4].value.as < std::string > ()), own(yystack_[2].value.as < t_const_value* > ()));
        driver.finish_node(yylhs.value.as < t_const* > (), LineType::Const, own(yystack_[1].value.as < t_annotations* > ()), own(yystack_[8].value.as < t_struct_annotations* > ()));
      } else {
        // TODO(afuller): Looks like a bug where driver.finish_node is never called in this case.
        delete yystack_[8].value.as < t_struct_annotations* > ();
        delete yystack_[5].value.as < t_type_ref* > ();
        delete yystack_[2].value.as < t_const_value* > ();
        delete yystack_[1].value.as < t_annotations* > ();
        yylhs.value.as < t_const* > () = nullptr;
      }
    }
#line 1931 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 50:
#line 665 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => tok_int_constant");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_bool(yystack_[0].value.as < int64_t > ());
    }
#line 1941 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 51:
#line 671 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => tok_int_constant");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_integer(yystack_[0].value.as < int64_t > ());
      if (driver.mode == parsing_mode::PROGRAM) {
        if (!driver.params.allow_64bit_consts && (yystack_[0].value.as < int64_t > () < INT32_MIN || yystack_[0].value.as < int64_t > () > INT32_MAX)) {
          driver.warning(1, "64-bit constant \"%" PRIi64 "\" may not work in all languages.", yystack_[0].value.as < int64_t > ());
        }
      }
    }
#line 1956 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 52:
#line 682 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => tok_dub_constant");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_double(yystack_[0].value.as < double > ());
    }
#line 1966 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 53:
#line 688 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => tok_literal");
      yylhs.value.as < t_const_value* > () = new t_const_value(yystack_[0].value.as < std::string > ());
    }
#line 1975 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 54:
#line 693 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => Identifier");
      t_const* constant = driver.scope_cache->get_constant(yystack_[0].value.as < std::string > ());
      driver.validate_not_ambiguous_enum(yystack_[0].value.as < std::string > ());
      if (constant == nullptr) {
        auto name_with_program_name = driver.program->name() + "." + yystack_[0].value.as < std::string > ();
        constant = driver.scope_cache->get_constant(name_with_program_name);
        driver.validate_not_ambiguous_enum(name_with_program_name);
      }
      if (constant != nullptr) {
        // Copy const_value to perform isolated mutations
        t_const_value* const_value = constant->get_value();
        yylhs.value.as < t_const_value* > () = const_value->clone().release();

        // We only want to clone the value, while discarding all real type
        // information.
        yylhs.value.as < t_const_value* > ()->set_ttype(nullptr);
        yylhs.value.as < t_const_value* > ()->set_is_enum(false);
        yylhs.value.as < t_const_value* > ()->set_enum(nullptr);
        yylhs.value.as < t_const_value* > ()->set_enum_value(nullptr);
      } else {
        if (driver.mode == parsing_mode::PROGRAM) {
          driver.warning(1, "Constant strings should be quoted: %s", yystack_[0].value.as < std::string > ().c_str());
        }
        yylhs.value.as < t_const_value* > () = new t_const_value(yystack_[0].value.as < std::string > ());
      }
    }
#line 2007 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 55:
#line 721 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => ConstList");
      yylhs.value.as < t_const_value* > () = yystack_[0].value.as < t_const_value* > ();
    }
#line 2016 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 56:
#line 726 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => ConstMap");
      yylhs.value.as < t_const_value* > () = yystack_[0].value.as < t_const_value* > ();
    }
#line 2025 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 57:
#line 731 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => ConstStruct");
      yylhs.value.as < t_const_value* > () = yystack_[0].value.as < t_const_value* > ();
    }
#line 2034 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 58:
#line 738 "parse/thrifty.yy"
    {
      driver.debug("ConstList => [ ConstListContents CommaOrSemicolonOptional ]");
      yylhs.value.as < t_const_value* > () = yystack_[2].value.as < t_const_value* > ();
    }
#line 2043 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 59:
#line 743 "parse/thrifty.yy"
    {
      driver.debug("ConstList => [ ]");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_list();
    }
#line 2053 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 60:
#line 751 "parse/thrifty.yy"
    {
      driver.debug("ConstListContents => ConstListContents CommaOrSemicolon ConstValue");
      yylhs.value.as < t_const_value* > () = yystack_[2].value.as < t_const_value* > ();
      yylhs.value.as < t_const_value* > ()->add_list(own(yystack_[0].value.as < t_const_value* > ()));
    }
#line 2063 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 61:
#line 757 "parse/thrifty.yy"
    {
      driver.debug("ConstListContents => ConstValue");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_list();
      yylhs.value.as < t_const_value* > ()->add_list(own(yystack_[0].value.as < t_const_value* > ()));
    }
#line 2074 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 62:
#line 766 "parse/thrifty.yy"
    {
      driver.debug("ConstMap => { ConstMapContents CommaOrSemicolonOptional }");
      yylhs.value.as < t_const_value* > () = yystack_[2].value.as < t_const_value* > ();
    }
#line 2083 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 63:
#line 772 "parse/thrifty.yy"
    {
      driver.debug("ConstMap => { }");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_map();
    }
#line 2093 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 64:
#line 780 "parse/thrifty.yy"
    {
      driver.debug("ConstMapContents => ConstMapContents CommaOrSemicolon ConstValue : ConstValue");
      yylhs.value.as < t_const_value* > () = yystack_[4].value.as < t_const_value* > ();
      yylhs.value.as < t_const_value* > ()->add_map(own(yystack_[2].value.as < t_const_value* > ()), own(yystack_[0].value.as < t_const_value* > ()));
    }
#line 2103 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 65:
#line 786 "parse/thrifty.yy"
    {
      driver.debug("ConstMapContents => ConstValue : ConstValue");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_map();
      yylhs.value.as < t_const_value* > ()->add_map(own(yystack_[2].value.as < t_const_value* > ()), own(yystack_[0].value.as < t_const_value* > ()));
    }
#line 2114 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 66:
#line 795 "parse/thrifty.yy"
    {
      driver.debug("ConstStruct => ConstStructType { ConstStructContents CommaOrSemicolonOptional }");
      yylhs.value.as < t_const_value* > () = yystack_[2].value.as < t_const_value* > ();
      yylhs.value.as < t_const_value* > ()->set_ttype(own(yystack_[4].value.as < t_type_ref* > ()));
    }
#line 2124 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 67:
#line 801 "parse/thrifty.yy"
    {
      driver.debug("ConstStruct => ConstStructType { }");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_map();
      yylhs.value.as < t_const_value* > ()->set_ttype(own(yystack_[2].value.as < t_type_ref* > ()));
    }
#line 2135 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 68:
#line 810 "parse/thrifty.yy"
    {
      driver.debug("ConstStructType -> Identifier");
      yylhs.value.as < t_type_ref* > () = driver.new_type_ref(std::move(yystack_[0].value.as < std::string > ()), nullptr, /*is_const=*/true).release();
    }
#line 2144 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 69:
#line 817 "parse/thrifty.yy"
    {
      driver.debug("ConstStructContents => ConstStructContents CommaOrSemicolon Identifier = ConstValue");
      yylhs.value.as < t_const_value* > () = yystack_[4].value.as < t_const_value* > ();
      yylhs.value.as < t_const_value* > ()->add_map(std::make_unique<t_const_value>(yystack_[2].value.as < std::string > ()), own(yystack_[0].value.as < t_const_value* > ()));
    }
#line 2154 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 70:
#line 823 "parse/thrifty.yy"
    {
      driver.debug("ConstStructContents => Identifier = ConstValue");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_map();
      yylhs.value.as < t_const_value* > ()->add_map(std::make_unique<t_const_value>(yystack_[2].value.as < std::string > ()), own(yystack_[0].value.as < t_const_value* > ()));
    }
#line 2165 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 71:
#line 832 "parse/thrifty.yy"
    {
      driver.start_node(LineType::Struct);
    }
#line 2173 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 72:
#line 836 "parse/thrifty.yy"
    {
      driver.debug("Struct => StructuredAnnotations tok_struct Identifier "
        "{ FieldList } TypeAnnotations");
      yylhs.value.as < t_struct* > () = new t_struct(driver.program);
      driver.finish_node(yylhs.value.as < t_struct* > (), LineType::Struct, yystack_[4].value.as < std::string > (), own(yystack_[2].value.as < t_field_list* > ()), own(yystack_[0].value.as < t_annotations* > ()), own(yystack_[7].value.as < t_struct_annotations* > ()));
      y_field_val = -1;
    }
#line 2185 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 73:
#line 846 "parse/thrifty.yy"
    {
      driver.start_node(LineType::Union);
    }
#line 2193 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 74:
#line 850 "parse/thrifty.yy"
    {
      driver.debug("Union => StructuredAnnotations tok_union Identifier "
        "{ FieldList } TypeAnnotations");
      yylhs.value.as < t_union* > () = new t_union(driver.program);
      driver.finish_node(yylhs.value.as < t_union* > (), LineType::Union, yystack_[4].value.as < std::string > (), own(yystack_[2].value.as < t_field_list* > ()), own(yystack_[0].value.as < t_annotations* > ()), own(yystack_[7].value.as < t_struct_annotations* > ()));
      y_field_val = -1;
    }
#line 2205 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 75:
#line 861 "parse/thrifty.yy"
    {
      driver.start_node(LineType::Xception);
    }
#line 2213 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 76:
#line 865 "parse/thrifty.yy"
    {
      driver.debug("Xception => StructuredAnnotations tok_xception "
        "Identifier { FieldList } TypeAnnotations");
      yylhs.value.as < t_exception* > () = new t_exception(driver.program);
      yylhs.value.as < t_exception* > ()->set_safety(yystack_[9].value.as < t_error_safety > ());
      yylhs.value.as < t_exception* > ()->set_kind(yystack_[8].value.as < t_error_kind > ());
      yylhs.value.as < t_exception* > ()->set_blame(yystack_[7].value.as < t_error_blame > ());
      driver.finish_node(yylhs.value.as < t_exception* > (), LineType::Xception, yystack_[4].value.as < std::string > (), own(yystack_[2].value.as < t_field_list* > ()), own(yystack_[0].value.as < t_annotations* > ()), own(yystack_[10].value.as < t_struct_annotations* > ()));

      const char* annotations[] = {"message", "code"};
      for (auto& annotation: annotations) {
        if (driver.mode == parsing_mode::PROGRAM
            && yylhs.value.as < t_exception* > ()->get_field_by_name(annotation) != nullptr
            && yylhs.value.as < t_exception* > ()->has_annotation(annotation)
            && strcmp(annotation, yylhs.value.as < t_exception* > ()->get_annotation(annotation).c_str()) != 0) {
          driver.warning(1, "Some generators (e.g. PHP) will ignore annotation '%s' "
                         "as it is also used as field", annotation);
        }
      }

      // Check that value of "message" annotation is
      // - a valid member of struct
      // - of type STRING
      if (driver.mode == parsing_mode::PROGRAM && yylhs.value.as < t_exception* > ()->has_annotation("message")) {
        const std::string& v = yylhs.value.as < t_exception* > ()->get_annotation("message");
        const auto* field = yylhs.value.as < t_exception* > ()->get_field_by_name(v);
        if (field == nullptr) {
          driver.failure("member specified as exception 'message' should be a valid"
                         " struct member, '%s' in '%s' is not", v.c_str(), yystack_[4].value.as < std::string > ().c_str());
        }

        if (!field->get_type()->is_string_or_binary()) {
          driver.failure("member specified as exception 'message' should be of type "
                         "STRING, '%s' in '%s' is not", v.c_str(), yystack_[4].value.as < std::string > ().c_str());
        }
      }

      y_field_val = -1;
    }
#line 2257 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 77:
#line 907 "parse/thrifty.yy"
    {
      driver.require_experimental_feature("error-classification");
      yylhs.value.as < t_error_safety > () = t_error_safety::safe;
    }
#line 2266 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 78:
#line 912 "parse/thrifty.yy"
    {
      yylhs.value.as < t_error_safety > () = {};
    }
#line 2274 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 79:
#line 918 "parse/thrifty.yy"
    {
      driver.require_experimental_feature("error-classification");
      yylhs.value.as < t_error_kind > () = t_error_kind::transient;
    }
#line 2283 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 80:
#line 924 "parse/thrifty.yy"
    {
      driver.require_experimental_feature("error-classification");
      yylhs.value.as < t_error_kind > () = t_error_kind::stateful;
    }
#line 2292 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 81:
#line 930 "parse/thrifty.yy"
    {
      driver.require_experimental_feature("error-classification");
      yylhs.value.as < t_error_kind > () = t_error_kind::permanent;
    }
#line 2301 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 82:
#line 935 "parse/thrifty.yy"
    {
      yylhs.value.as < t_error_kind > () = {};
    }
#line 2309 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 83:
#line 941 "parse/thrifty.yy"
    {
      driver.require_experimental_feature("error-classification");
      yylhs.value.as < t_error_blame > () = t_error_blame::client;
    }
#line 2318 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 84:
#line 947 "parse/thrifty.yy"
    {
      driver.require_experimental_feature("error-classification");
      yylhs.value.as < t_error_blame > () = t_error_blame::server;
    }
#line 2327 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 85:
#line 952 "parse/thrifty.yy"
    {
      yylhs.value.as < t_error_blame > () = {};
    }
#line 2335 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 86:
#line 959 "parse/thrifty.yy"
    {
      driver.start_node(LineType::Service);
    }
#line 2343 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 87:
#line 963 "parse/thrifty.yy"
    {
      driver.debug("Service => StructuredAnnotations tok_service "
        "Identifier Extends { FlagArgs FunctionList UnflagArgs } "
        "FunctionAnnotations");
      yylhs.value.as < t_service* > () = yystack_[3].value.as < t_service* > ();
      yylhs.value.as < t_service* > ()->set_extends(yystack_[6].value.as < t_service* > ());
      driver.finish_node(yylhs.value.as < t_service* > (), LineType::Service, yystack_[7].value.as < std::string > (), own(yystack_[0].value.as < t_annotations* > ()), own(yystack_[10].value.as < t_struct_annotations* > ()));
    }
#line 2356 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 88:
#line 973 "parse/thrifty.yy"
    {
       g_arglist = 1;
    }
#line 2364 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 89:
#line 978 "parse/thrifty.yy"
    {
       g_arglist = 0;
    }
#line 2372 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 90:
#line 984 "parse/thrifty.yy"
    {
      driver.debug("Extends -> tok_extends Identifier");
      yylhs.value.as < t_service* > () = nullptr;
      if (driver.mode == parsing_mode::PROGRAM) {
        yylhs.value.as < t_service* > () = driver.scope_cache->get_service(yystack_[0].value.as < std::string > ());
        if (!yylhs.value.as < t_service* > ()) {
          yylhs.value.as < t_service* > () = driver.scope_cache->get_service(driver.program->name() + "." + yystack_[0].value.as < std::string > ());
        }
        if (!yylhs.value.as < t_service* > ()) {
          driver.failure("Service \"%s\" has not been defined.", yystack_[0].value.as < std::string > ().c_str());
        }
      }
    }
#line 2390 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 91:
#line 998 "parse/thrifty.yy"
    {
      yylhs.value.as < t_service* > () = nullptr;
    }
#line 2398 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 92:
#line 1005 "parse/thrifty.yy"
    {
      driver.start_node(LineType::Service);
    }
#line 2406 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 93:
#line 1009 "parse/thrifty.yy"
    {
      driver.debug("Interaction -> tok_interaction Identifier { FunctionList }");
      yylhs.value.as < t_service* > () = yystack_[3].value.as < t_service* > ();
      yylhs.value.as < t_service* > ()->set_is_interaction();
      driver.finish_node(yylhs.value.as < t_service* > (), LineType::Service, yystack_[6].value.as < std::string > (), own(yystack_[0].value.as < t_annotations* > ()), nullptr);

      for (auto* func : yylhs.value.as < t_service* > ()->get_functions()) {
        func->set_is_interaction_member();
        if (func->has_annotation("thread")) {
          driver.failure("Interaction methods cannot be individually annotated with "
            "thread='eb'. Use process_in_event_base on the interaction instead.");
        }
      }
      if (yylhs.value.as < t_service* > ()->has_annotation("process_in_event_base")) {
        if (yylhs.value.as < t_service* > ()->has_annotation("serial")) {
          driver.failure("EB interactions are already serial");
        }
        for (auto* func : yylhs.value.as < t_service* > ()->get_functions()) {
          func->set_annotation("thread", "eb");
        }
      } else if (yylhs.value.as < t_service* > ()->has_annotation("serial")) {
        yylhs.value.as < t_service* > ()->set_is_serial_interaction();
      }
    }
#line 2435 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 94:
#line 1036 "parse/thrifty.yy"
    {
      driver.debug("FunctionList -> FunctionList Function");
      yylhs.value.as < t_service* > () = yystack_[1].value.as < t_service* > ();
      yystack_[1].value.as < t_service* > ()->add_function(own(yystack_[0].value.as < t_function* > ()));
    }
#line 2445 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 95:
#line 1042 "parse/thrifty.yy"
    {
      driver.debug("FunctionList -> ");
      yylhs.value.as < t_service* > () = new t_service(driver.program);
    }
#line 2454 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 96:
#line 1049 "parse/thrifty.yy"
    {
      driver.debug("Function => CaptureDocText StructuredAnnotations FunctionQualifier "
        "FunctionType Identifier ( ParamList ) MaybeThrows "
        "FunctionAnnotations CommaOrSemicolonOptional");
      yystack_[4].value.as < t_paramlist* > ()->set_name(std::string(yystack_[6].value.as < std::string > ()) + "_args");
      auto rettype = own(yystack_[7].value.as < t_type_ref* > ());
      auto* paramlist = yystack_[4].value.as < t_paramlist* > ();
      t_struct* streamthrows = nullptr;
      if (const auto* tstream_resp = dynamic_cast<const t_stream_response*>(rettype->type())) {
        streamthrows = tstream_resp->get_throws_struct();
      }
      t_function* func;
      if (const auto* tsink = dynamic_cast<const t_sink*>(rettype->type())) {
        // TODO(afuller): Remove special case for sink.
        func = new t_function(
          tsink,
          yystack_[6].value.as < std::string > (),
          own(paramlist),
          own(yystack_[2].value.as < t_struct* > ())
        );
      } else {
        func = new t_function(
          std::move(*rettype),
          yystack_[6].value.as < std::string > (),
          own(paramlist),
          own(yystack_[2].value.as < t_struct* > ()),
          own(streamthrows),
          yystack_[8].value.as < t_function_qualifier > ()
        );
      }
      yylhs.value.as < t_function* > () = func;
      driver.set_annotations(yylhs.value.as < t_function* > (), own(yystack_[1].value.as < t_annotations* > ()), own(yystack_[9].value.as < t_struct_annotations* > ()));
      if (yystack_[10].value.as < t_doc > ()) {
        yylhs.value.as < t_function* > ()->set_doc(std::string{*yystack_[10].value.as < t_doc > ()});
      }
      yylhs.value.as < t_function* > ()->set_lineno(driver.scanner->get_lineno());
      y_field_val = -1;
    }
#line 2497 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 97:
#line 1088 "parse/thrifty.yy"
    {
      driver.debug("Function => tok_performs FieldType");
      auto ret = own(yystack_[1].value.as < t_type_ref* > ());
      std::string name = ret->type()
          ? "create" + ret->type()->get_name()
          : "<interaction placeholder>";
      yylhs.value.as < t_function* > () = new t_function(
        std::move(*ret),
        std::move(name),
        std::make_unique<t_paramlist>(driver.program)
      );
      yylhs.value.as < t_function* > ()->set_lineno(driver.scanner->get_lineno());
      yylhs.value.as < t_function* > ()->set_is_interaction_constructor();
    }
#line 2516 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 98:
#line 1105 "parse/thrifty.yy"
    {
      driver.debug("ParamList -> ParamList , Param");
      yylhs.value.as < t_paramlist* > () = yystack_[1].value.as < t_paramlist* > ();
      auto param = own(yystack_[0].value.as < t_field* > ());
      if (!yylhs.value.as < t_paramlist* > ()->try_append_field(std::move(param))) {
        driver.failure("Parameter identifier %d for \"%s\" has already been used",
                       param->get_key(), param->get_name().c_str());
      }
    }
#line 2530 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 99:
#line 1115 "parse/thrifty.yy"
    {
      yylhs.value.as < t_paramlist* > () = yystack_[0].value.as < t_paramlist* > ();
    }
#line 2538 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 100:
#line 1120 "parse/thrifty.yy"
    {
      driver.debug("EmptyParamList -> nil");
      yylhs.value.as < t_paramlist* > () = new t_paramlist(driver.program);
    }
#line 2547 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 101:
#line 1127 "parse/thrifty.yy"
    {
      driver.debug("Param -> Field");
      yylhs.value.as < t_field* > () = yystack_[0].value.as < t_field* > ();
    }
#line 2556 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 102:
#line 1134 "parse/thrifty.yy"
    {
      yylhs.value.as < t_function_qualifier > () = t_function_qualifier::one_way;
    }
#line 2564 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 103:
#line 1138 "parse/thrifty.yy"
    {
      driver.require_experimental_feature("idempotency");
      yylhs.value.as < t_function_qualifier > () = t_function_qualifier::idempotent;
    }
#line 2573 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 104:
#line 1143 "parse/thrifty.yy"
    {
      driver.require_experimental_feature("idempotency");
      yylhs.value.as < t_function_qualifier > () = t_function_qualifier::read_only;
    }
#line 2582 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 105:
#line 1148 "parse/thrifty.yy"
    {
      yylhs.value.as < t_function_qualifier > () = t_function_qualifier::none;
    }
#line 2590 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 106:
#line 1154 "parse/thrifty.yy"
    {
      driver.debug("Throws -> tok_throws ( FieldList )");
      yylhs.value.as < t_struct* > () = driver.new_throws(own(yystack_[1].value.as < t_field_list* > ())).release();
    }
#line 2599 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 107:
#line 1160 "parse/thrifty.yy"
                {
			yylhs.value.as < t_struct* > () = yystack_[0].value.as < t_struct* > ();
		}
#line 2607 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 108:
#line 1163 "parse/thrifty.yy"
    {
      yylhs.value.as < t_struct* > () = driver.new_throws().release();
		}
#line 2615 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 109:
#line 1169 "parse/thrifty.yy"
    {
      driver.debug("FieldList -> FieldList Field");
      yylhs.value.as < t_field_list* > () = yystack_[1].value.as < t_field_list* > ();
      yylhs.value.as < t_field_list* > ()->emplace_back(yystack_[0].value.as < t_field* > ());
    }
#line 2625 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 110:
#line 1175 "parse/thrifty.yy"
    {
      driver.debug("FieldList -> ");
      yylhs.value.as < t_field_list* > () = new t_field_list;
    }
#line 2634 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 111:
#line 1182 "parse/thrifty.yy"
    {
      driver.start_node(LineType::Field);
    }
#line 2642 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 112:
#line 1186 "parse/thrifty.yy"
    {
      driver.debug("Field => CaptureDocText FieldIdentifier FieldRequiredness "
        "FieldType Identifier FieldValue TypeAnnotations "
        "StructuredAnnotations CommaOrSemicolonOptional");
      if (yystack_[7].value.as < t_field_id > ().auto_assigned) {
        driver.warning(1, "No field key specified for %s, resulting protocol may have conflicts "
          "or not be backwards compatible!", yystack_[3].value.as < std::string > ().c_str());
        if (driver.params.strict >= 192) {
          driver.failure("Implicit field keys are deprecated and not allowed with -strict");
        }
      }

      yylhs.value.as < t_field* > () = new t_field(consume(yystack_[4].value.as < t_type_ref* > ()), std::move(yystack_[3].value.as < std::string > ()), yystack_[7].value.as < t_field_id > ().value);
      if (yystack_[9].value.as < t_doc > ()) {
        yylhs.value.as < t_field* > ()->set_doc(std::move(*yystack_[9].value.as < t_doc > ()));
      }
      yylhs.value.as < t_field* > ()->set_req(yystack_[5].value.as < t_field::e_req > ());
      if (yystack_[2].value.as < t_const_value* > ()) {
        driver.validate_field_value(yylhs.value.as < t_field* > (), yystack_[2].value.as < t_const_value* > ());
        yylhs.value.as < t_field* > ()->set_value(own(yystack_[2].value.as < t_const_value* > ()));
      }
      driver.finish_node(yylhs.value.as < t_field* > (), LineType::Field, own(yystack_[1].value.as < t_annotations* > ()), own(yystack_[8].value.as < t_struct_annotations* > ()));

      if (yystack_[5].value.as < t_field::e_req > () != t_field::e_req::optional && yylhs.value.as < t_field* > ()->has_annotation({"cpp.ref", "cpp2.ref"})) {
        driver.warning(1, "`cpp.ref` field must be optional if it is recursive.");
      }
    }
#line 2674 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 113:
#line 1216 "parse/thrifty.yy"
    {
      if (yystack_[1].value.as < int64_t > () <= 0) {
        if (driver.params.allow_neg_field_keys) {
          /*
           * allow_neg_field_keys exists to allow users to add explicitly
           * specified key values to old .thrift files without breaking
           * protocol compatibility.
           */
          if (yystack_[1].value.as < int64_t > () != y_field_val) {
            /*
             * warn if the user-specified negative value isn't what
             * thrift would have auto-assigned.
             */
            driver.warning(1, "Negative field key (%d) differs from what would be "
                           "auto-assigned by thrift (%d).", yystack_[1].value.as < int64_t > (), y_field_val);
          }
          /*
           * Leave $1 as-is, and update y_field_val to be one less than $1.
           * The FieldList parsing will catch any duplicate key values.
           */
          y_field_val = yystack_[1].value.as < int64_t > () - 1;
          yylhs.value.as < t_field_id > ().value = yystack_[1].value.as < int64_t > ();
          yylhs.value.as < t_field_id > ().auto_assigned = false;
        } else {
          driver.warning(1, "Nonpositive value (%d) not allowed as a field key.",
                         yystack_[1].value.as < int64_t > ());
          yylhs.value.as < t_field_id > ().value = y_field_val--;
          yylhs.value.as < t_field_id > ().auto_assigned = true;
        }
      } else {
        yylhs.value.as < t_field_id > ().value = yystack_[1].value.as < int64_t > ();
        yylhs.value.as < t_field_id > ().auto_assigned = false;
      }
    }
#line 2713 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 114:
#line 1251 "parse/thrifty.yy"
    {
      yylhs.value.as < t_field_id > ().value = y_field_val--;
      yylhs.value.as < t_field_id > ().auto_assigned = true;
    }
#line 2722 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 115:
#line 1258 "parse/thrifty.yy"
    {
      if (g_arglist) {
        if (driver.mode == parsing_mode::PROGRAM) {
          driver.warning(1, "required keyword is ignored in argument lists.");
        }
        yylhs.value.as < t_field::e_req > () = t_field::e_req::opt_in_req_out;
      } else {
        yylhs.value.as < t_field::e_req > () = t_field::e_req::required;
      }
    }
#line 2737 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 116:
#line 1269 "parse/thrifty.yy"
    {
      if (g_arglist) {
        if (driver.mode == parsing_mode::PROGRAM) {
          driver.warning(1, "optional keyword is ignored in argument lists.");
        }
        yylhs.value.as < t_field::e_req > () = t_field::e_req::opt_in_req_out;
      } else {
        yylhs.value.as < t_field::e_req > () = t_field::e_req::optional;
      }
    }
#line 2752 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 117:
#line 1280 "parse/thrifty.yy"
    {
      yylhs.value.as < t_field::e_req > () = t_field::e_req::opt_in_req_out;
    }
#line 2760 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 118:
#line 1286 "parse/thrifty.yy"
    {
      if (driver.mode == parsing_mode::PROGRAM) {
        yylhs.value.as < t_const_value* > () = yystack_[0].value.as < t_const_value* > ();
      } else {
        delete yystack_[0].value.as < t_const_value* > ();
        yylhs.value.as < t_const_value* > () = nullptr;
      }
    }
#line 2773 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 119:
#line 1295 "parse/thrifty.yy"
    {
      yylhs.value.as < t_const_value* > () = nullptr;
    }
#line 2781 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 120:
#line 1301 "parse/thrifty.yy"
    {
      driver.debug("FunctionType -> ResponseAndStreamReturnType");
      yylhs.value.as < t_type_ref* > () = driver.new_type_ref(own(yystack_[0].value.as < t_stream_response* > ()), nullptr).release();
    }
#line 2790 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 121:
#line 1306 "parse/thrifty.yy"
    {
      driver.debug("FunctionType -> ResponseAndSinkReturnType");
      yylhs.value.as < t_type_ref* > () = driver.new_type_ref(own(yystack_[0].value.as < t_sink* > ()), nullptr).release();
    }
#line 2799 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 122:
#line 1311 "parse/thrifty.yy"
    {
      driver.debug("FunctionType -> FieldType");
      yylhs.value.as < t_type_ref* > () = yystack_[0].value.as < t_type_ref* > ();
    }
#line 2808 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 123:
#line 1316 "parse/thrifty.yy"
    {
      driver.debug("FunctionType -> tok_void");
      yylhs.value.as < t_type_ref* > () = new t_type_ref(&t_base_type::t_void());
    }
#line 2817 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 124:
#line 1323 "parse/thrifty.yy"
    {
      driver.debug("ResponseAndStreamReturnType -> FieldType, StreamReturnType");
      yystack_[0].value.as < t_stream_response* > ()->set_first_response_type(own(yystack_[2].value.as < t_type_ref* > ()));
      yylhs.value.as < t_stream_response* > () = yystack_[0].value.as < t_stream_response* > ();
    }
#line 2827 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 125:
#line 1329 "parse/thrifty.yy"
    {
      driver.debug("ResponseAndStreamReturnType -> StreamReturnType");
      yylhs.value.as < t_stream_response* > () = yystack_[0].value.as < t_stream_response* > ();
    }
#line 2836 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 126:
#line 1336 "parse/thrifty.yy"
  {
    driver.debug("StreamReturnType -> tok_stream < FieldType >");
    yylhs.value.as < t_stream_response* > () = new t_stream_response(consume(yystack_[1].value.as < t_type_ref* > ()));
  }
#line 2845 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 127:
#line 1341 "parse/thrifty.yy"
  {
    driver.debug("StreamReturnType -> tok_stream < FieldType Throws >");
    yylhs.value.as < t_stream_response* > () = new t_stream_response(consume(yystack_[2].value.as < t_type_ref* > ()), yystack_[1].value.as < t_struct* > ());
  }
#line 2854 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 128:
#line 1348 "parse/thrifty.yy"
    {
      driver.debug("ResponseAndSinkReturnType -> FieldType, SinkReturnType");
      yystack_[0].value.as < t_sink* > ()->set_first_response_type(own(yystack_[2].value.as < t_type_ref* > ()));
      yylhs.value.as < t_sink* > () = yystack_[0].value.as < t_sink* > ();
    }
#line 2864 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 129:
#line 1354 "parse/thrifty.yy"
    {
      driver.debug("ResponseAndSinkReturnType -> SinkReturnType");
      yylhs.value.as < t_sink* > () = yystack_[0].value.as < t_sink* > ();
    }
#line 2873 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 130:
#line 1361 "parse/thrifty.yy"
    {
      driver.debug("SinkReturnType -> tok_sink<FieldType, FieldType>");
      yylhs.value.as < t_sink* > () = new t_sink(
        consume(yystack_[3].value.as < t_typestructpair > ().first), yystack_[3].value.as < t_typestructpair > ().second,
        consume(yystack_[1].value.as < t_typestructpair > ().first), yystack_[1].value.as < t_typestructpair > ().second);
    }
#line 2884 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 131:
#line 1369 "parse/thrifty.yy"
    {
      yylhs.value.as < t_typestructpair > () = std::make_pair(yystack_[0].value.as < t_type_ref* > (), nullptr);
    }
#line 2892 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 132:
#line 1373 "parse/thrifty.yy"
    {
      yylhs.value.as < t_typestructpair > () = std::make_pair(yystack_[1].value.as < t_type_ref* > (), yystack_[0].value.as < t_struct* > ());
    }
#line 2900 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 133:
#line 1379 "parse/thrifty.yy"
    {
      driver.debug("FieldType => Identifier TypeAnnotations");
      yylhs.value.as < t_type_ref* > () = driver.new_type_ref(std::move(yystack_[1].value.as < std::string > ()), own(yystack_[0].value.as < t_annotations* > ())).release();
    }
#line 2909 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 134:
#line 1384 "parse/thrifty.yy"
    {
      driver.debug("FieldType -> BaseType");
      yylhs.value.as < t_type_ref* > () = driver.new_type_ref(yystack_[1].value.as < t_ref<t_base_type> > (), own(yystack_[0].value.as < t_annotations* > ())).release();
    }
#line 2918 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 135:
#line 1389 "parse/thrifty.yy"
    {
      driver.debug("FieldType -> ContainerType");
      yylhs.value.as < t_type_ref* > () = driver.new_type_ref(own(yystack_[1].value.as < t_container* > ()), own(yystack_[0].value.as < t_annotations* > ())).release();
    }
#line 2927 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 136:
#line 1396 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_string");
      yylhs.value.as < t_ref<t_base_type> > () = &t_base_type::t_string();
    }
#line 2936 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 137:
#line 1401 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_binary");
      yylhs.value.as < t_ref<t_base_type> > () = &t_base_type::t_binary();
    }
#line 2945 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 138:
#line 1406 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_bool");
      yylhs.value.as < t_ref<t_base_type> > () = &t_base_type::t_bool();
    }
#line 2954 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 139:
#line 1411 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_byte");
      yylhs.value.as < t_ref<t_base_type> > () = &t_base_type::t_byte();
    }
#line 2963 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 140:
#line 1416 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_i16");
      yylhs.value.as < t_ref<t_base_type> > () = &t_base_type::t_i16();
    }
#line 2972 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 141:
#line 1421 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_i32");
      yylhs.value.as < t_ref<t_base_type> > () = &t_base_type::t_i32();
    }
#line 2981 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 142:
#line 1426 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_i64");
      yylhs.value.as < t_ref<t_base_type> > () = &t_base_type::t_i64();
    }
#line 2990 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 143:
#line 1431 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_double");
      yylhs.value.as < t_ref<t_base_type> > () = &t_base_type::t_double();
    }
#line 2999 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 144:
#line 1436 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_float");
      yylhs.value.as < t_ref<t_base_type> > () = &t_base_type::t_float();
    }
#line 3008 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 145:
#line 1443 "parse/thrifty.yy"
    {
      driver.debug("ContainerType -> MapType");
      yylhs.value.as < t_container* > () = yystack_[0].value.as < t_container* > ();
    }
#line 3017 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 146:
#line 1448 "parse/thrifty.yy"
    {
      driver.debug("ContainerType -> SetType");
      yylhs.value.as < t_container* > () = yystack_[0].value.as < t_container* > ();
    }
#line 3026 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 147:
#line 1453 "parse/thrifty.yy"
    {
      driver.debug("ContainerType -> ListType");
      yylhs.value.as < t_container* > () = yystack_[0].value.as < t_container* > ();
    }
#line 3035 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 148:
#line 1460 "parse/thrifty.yy"
    {
      driver.debug("MapType -> tok_map<FieldType, FieldType>");
      yylhs.value.as < t_container* > () = new t_map(consume(yystack_[3].value.as < t_type_ref* > ()), consume(yystack_[1].value.as < t_type_ref* > ()));
    }
#line 3044 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 149:
#line 1467 "parse/thrifty.yy"
    {
      driver.debug("SetType -> tok_set<FieldType>");
      yylhs.value.as < t_container* > () = new t_set(consume(yystack_[1].value.as < t_type_ref* > ()));
    }
#line 3053 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 150:
#line 1474 "parse/thrifty.yy"
    {
      driver.debug("ListType -> tok_list<FieldType>");
      yylhs.value.as < t_container* > () = new t_list(consume(yystack_[1].value.as < t_type_ref* > ()));
    }
#line 3062 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 151:
#line 1481 "parse/thrifty.yy"
    {
      yystack_[1].value.as < t_annotations* > ()->last_lineno = driver.scanner->get_lineno();
    }
#line 3070 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 152:
#line 1485 "parse/thrifty.yy"
    {
      driver.debug("TypeAnnotations => ( TypeAnnotationList CommaOrSemicolonOptional)");
      yylhs.value.as < t_annotations* > () = yystack_[3].value.as < t_annotations* > ();
    }
#line 3079 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 153:
#line 1490 "parse/thrifty.yy"
    {
      driver.debug("TypeAnnotations => ( )");
      yylhs.value.as < t_annotations* > () = nullptr;
    }
#line 3088 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 154:
#line 1495 "parse/thrifty.yy"
    {
      driver.debug("TypeAnnotations =>");
      yylhs.value.as < t_annotations* > () = nullptr;
    }
#line 3097 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 155:
#line 1502 "parse/thrifty.yy"
    {
      driver.debug("TypeAnnotationList => TypeAnnotationList CommaOrSemicolon TypeAnnotation");
      yylhs.value.as < t_annotations* > () = yystack_[2].value.as < t_annotations* > ();
      yylhs.value.as < t_annotations* > ()->strings[yystack_[0].value.as < t_annotation* > ()->first] = std::move(yystack_[0].value.as < t_annotation* > ()->second);
      delete yystack_[0].value.as < t_annotation* > ();
    }
#line 3108 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 156:
#line 1509 "parse/thrifty.yy"
    {
      driver.debug("TypeAnnotationList => TypeAnnotation");
      /* Just use a dummy structure to hold the annotations. */
      yylhs.value.as < t_annotations* > () = new t_annotations();
      yylhs.value.as < t_annotations* > ()->strings[yystack_[0].value.as < t_annotation* > ()->first] = std::move(yystack_[0].value.as < t_annotation* > ()->second);
      delete yystack_[0].value.as < t_annotation* > ();
    }
#line 3120 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 157:
#line 1519 "parse/thrifty.yy"
    {
      driver.debug("TypeAnnotation -> Identifier = IntOrLiteral");
      yylhs.value.as < t_annotation* > () = new t_annotation{yystack_[2].value.as < std::string > (), yystack_[0].value.as < std::string > ()};
    }
#line 3129 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 158:
#line 1524 "parse/thrifty.yy"
    {
      driver.debug("TypeAnnotation -> Identifier");
      yylhs.value.as < t_annotation* > () = new t_annotation{yystack_[0].value.as < std::string > (), "1"};
    }
#line 3138 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 159:
#line 1531 "parse/thrifty.yy"
    {
      driver.debug("StructuredAnnotations -> NonEmptyStructuredAnnotationList");
      yylhs.value.as < t_struct_annotations* > () = yystack_[0].value.as < t_struct_annotations* > ();
    }
#line 3147 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 160:
#line 1536 "parse/thrifty.yy"
    {
      driver.debug("StructuredAnnotations ->");
      yylhs.value.as < t_struct_annotations* > () = nullptr;
    }
#line 3156 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 161:
#line 1543 "parse/thrifty.yy"
    {
      driver.debug("NonEmptyStructuredAnnotationList -> NonEmptyStructuredAnnotationList StructuredAnnotation");
      yylhs.value.as < t_struct_annotations* > () = yystack_[1].value.as < t_struct_annotations* > ();
      yylhs.value.as < t_struct_annotations* > ()->emplace_back(yystack_[0].value.as < t_const* > ());
    }
#line 3166 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 162:
#line 1549 "parse/thrifty.yy"
    {
      driver.debug("NonEmptyStructuredAnnotationList ->");
      yylhs.value.as < t_struct_annotations* > () = new t_struct_annotations;
      yylhs.value.as < t_struct_annotations* > ()->emplace_back(yystack_[0].value.as < t_const* > ());
    }
#line 3176 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 163:
#line 1557 "parse/thrifty.yy"
    {
      driver.debug("StructuredAnnotation => @ConstStruct");
      yylhs.value.as < t_const* > () = driver.new_struct_annotation(own(yystack_[0].value.as < t_const_value* > ())).release();
    }
#line 3185 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 164:
#line 1562 "parse/thrifty.yy"
    {
      driver.debug("StructuredAnnotation => @ConstStructType");
      auto value = std::make_unique<t_const_value>();
      value->set_map();
      value->set_ttype(own(yystack_[0].value.as < t_type_ref* > ()));
      yylhs.value.as < t_const* > () = driver.new_struct_annotation(std::move(value)).release();
    }
#line 3197 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 165:
#line 1572 "parse/thrifty.yy"
    {
      driver.debug("FunctionAnnotations => TypeAnnotations");
      if (!yystack_[0].value.as < t_annotations* > ()) {
        yylhs.value.as < t_annotations* > () = nullptr;
        break;
      }
      yylhs.value.as < t_annotations* > () = yystack_[0].value.as < t_annotations* > ();
      auto priority = yylhs.value.as < t_annotations* > ()->strings.find("priority");
      if (priority == yylhs.value.as < t_annotations* > ()->strings.end()) {
        break;
      }
      const std::string& prio = priority->second;
      const std::string prio_list[] = {"HIGH_IMPORTANT", "HIGH", "IMPORTANT",
                                       "NORMAL", "BEST_EFFORT"};
      const auto end = prio_list + sizeof(prio_list)/sizeof(prio_list[0]);
      if (std::find(prio_list, end, prio) == end) {
        std::string s;
        for (const auto& prio : prio_list) {
          s += prio + "','";
        }
        s.erase(s.length() - 3);
        driver.failure("Bad priority '%s'. Choose one of '%s'.",
                       prio.c_str(), s.c_str());
      }
    }
#line 3227 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 166:
#line 1600 "parse/thrifty.yy"
    {
      driver.debug("IntOrLiteral -> tok_literal");
      yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > ();
    }
#line 3236 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 167:
#line 1606 "parse/thrifty.yy"
    {
      char buf[21];  // max len of int64_t as string + null terminator
      driver.debug("IntOrLiteral -> tok_bool_constant");
      sprintf(buf, "%" PRIi64, yystack_[0].value.as < int64_t > ());
      yylhs.value.as < std::string > () = buf;
    }
#line 3247 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;

  case 168:
#line 1614 "parse/thrifty.yy"
    {
      char buf[21];  // max len of int64_t as string + null terminator
      driver.debug("IntOrLiteral -> tok_int_constant");
      sprintf(buf, "%" PRIi64, yystack_[0].value.as < int64_t > ());
      yylhs.value.as < std::string > () = buf;
    }
#line 3258 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"
    break;


#line 3262 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;
      YY_STACK_PRINT ();

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        error (yysyntax_error_ (yystack_[0].state, yyla));
      }


    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.type_get () == yyeof_)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    {
      stack_symbol_type error_token;
      for (;;)
        {
          yyn = yypact_[yystack_[0].state];
          if (!yy_pact_value_is_default_ (yyn))
            {
              yyn += yy_error_token_;
              if (0 <= yyn && yyn <= yylast_ && yycheck_[yyn] == yy_error_token_)
                {
                  yyn = yytable_[yyn];
                  if (0 < yyn)
                    break;
                }
            }

          // Pop the current state because it cannot handle the error token.
          if (yystack_.size () == 1)
            YYABORT;

          yy_destroy_ ("Error: popping", yystack_[0]);
          yypop_ ();
          YY_STACK_PRINT ();
        }


      // Shift the error token.
      error_token.state = static_cast<state_type> (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
  parser::error (const syntax_error& yyexc)
  {
    error (yyexc.what ());
  }

  // Generate an error message.
  std::string
  parser::yysyntax_error_ (state_type, const symbol_type&) const
  {
    return YY_("syntax error");
  }


  const short parser::yypact_ninf_ = -242;

  const signed char parser::yytable_ninf_ = -90;

  const short
  parser::yypact_[] =
  {
    -242,    13,     9,  -242,    20,    18,    17,   157,    26,    45,
    -242,  -242,   -15,  -242,  -242,  -242,  -242,  -242,  -242,  -242,
    -242,  -242,  -242,  -242,  -242,  -242,    79,  -242,  -242,   157,
    -242,  -242,  -242,  -242,  -242,  -242,  -242,  -242,  -242,   274,
       4,  -242,  -242,  -242,  -242,  -242,    29,   157,  -242,  -242,
    -242,  -242,  -242,  -242,  -242,   -10,  -242,   134,    44,   241,
     157,   157,   157,   241,   157,  -242,  -242,  -242,    22,  -242,
      50,    63,  -242,  -242,  -242,  -242,  -242,  -242,  -242,  -242,
    -242,  -242,    46,    49,    61,    67,   157,    67,    67,  -242,
    -242,  -242,    75,    36,  -242,   157,    82,  -242,  -242,    48,
     309,  -242,  -242,   157,    84,  -242,   241,   241,   241,   319,
    -242,    67,  -242,  -242,  -242,   157,    86,    87,    89,  -242,
    -242,  -242,  -242,  -242,  -242,   251,   299,    92,  -242,  -242,
    -242,  -242,    29,    91,  -242,   -11,    96,    88,    94,  -242,
      93,    63,  -242,  -242,    99,  -242,  -242,  -242,   309,   104,
     157,  -242,   113,    63,  -242,  -242,    63,   309,   241,     4,
     118,  -242,   241,  -242,  -242,    21,   157,  -242,    67,     4,
    -242,  -242,   119,    67,    67,   121,   309,   309,   122,   309,
     123,  -242,   127,    19,    67,   124,  -242,  -242,  -242,  -242,
    -242,   115,  -242,   132,   -11,    67,     4,  -242,    63,  -242,
    -242,  -242,   125,  -242,  -242,  -242,  -242,  -242,  -242,  -242,
     193,  -242,  -242,  -242,   129,  -242,   131,  -242,   157,  -242,
    -242,   135,   309,  -242,   136,   137,   157,  -242,  -242,  -242,
    -242,   144,  -242,    16,    67,   147,    67,    67,  -242,   241,
     241,   140,    37,  -242,  -242,   241,  -242,  -242,   155,    63,
    -242,   -12,   154,   111,  -242,   137,  -242,  -242,   157,  -242,
    -242,  -242,   149,   150,   241,  -242,   166,  -242,   160,  -242,
    -242,   165,   111,  -242,  -242,   309,    67,   168,  -242,  -242,
      67,  -242,    63,  -242,    63,  -242,  -242
  };

  const unsigned char
  parser::yydefact_[] =
  {
      17,     0,    25,     1,     0,    14,     0,     0,     0,     0,
      16,    18,   160,    24,    23,     3,     4,     5,     7,     6,
       8,     9,    10,    11,    12,    13,     0,    21,    22,     0,
      92,    27,    28,    26,    29,    30,    31,    32,    33,    78,
     159,   162,    20,    19,    68,   163,   164,     0,    77,    34,
      71,    86,    40,    48,    73,    82,   161,     0,     0,     0,
       0,     0,     0,     0,     0,    79,    80,    81,    85,    67,
       0,    39,    88,   138,   139,   136,   137,   140,   141,   142,
     143,   144,     0,     0,     0,   154,     0,   154,   154,   145,
     146,   147,     0,    91,    41,     0,     0,    84,    83,     0,
       0,    36,    37,    38,     0,    95,     0,     0,     0,     0,
     133,   154,   134,   135,   110,     0,     0,     0,     0,   110,
      75,    53,    50,    51,    52,     0,     0,    54,    70,    55,
      56,    57,     0,     0,    66,    14,     0,     0,     0,   153,
     158,    39,   156,    35,    14,    90,    88,    44,     0,    14,
       0,    63,     0,    39,    59,    61,    39,     0,     0,   160,
       0,    94,     0,   150,   149,     0,    38,   151,   154,   160,
     109,    95,    14,   154,   154,     0,     0,    38,     0,    38,
       0,    69,     0,   105,   154,     0,   166,   167,   168,   157,
     155,     0,    72,   114,    14,   154,   160,    43,    39,    74,
     110,    65,     0,    62,    60,    58,    97,   102,   103,   104,
       0,    93,   148,   152,     0,   111,     0,    42,     0,    38,
      49,    14,     0,   123,     0,     4,     0,   120,   125,   121,
     129,   122,   113,   117,   154,    47,   154,   154,    64,     0,
       0,     0,     0,   115,   116,     0,   165,    87,     0,    39,
      76,     0,     0,   131,   100,     0,   124,   128,     0,    46,
      45,   126,     0,     0,     0,   132,    14,    99,   119,   110,
     127,     0,   108,    98,   101,     0,   154,    14,   130,   107,
     154,   118,    39,   106,    39,   112,    96
  };

  const short
  parser::yypgoto_[] =
  {
    -242,  -242,    -7,     1,  -242,  -242,  -242,  -242,  -242,  -242,
    -242,  -242,   -61,  -133,  -242,  -242,  -242,  -242,  -242,  -242,
    -242,  -242,  -109,  -242,  -242,  -242,  -242,   139,   159,  -242,
    -242,  -242,  -242,  -242,  -242,  -242,  -242,  -242,  -242,  -242,
    -242,    43,    -4,  -242,  -242,  -242,    23,  -242,  -242,  -242,
    -242,  -242,  -241,  -242,  -114,   -73,  -242,  -242,  -242,  -242,
    -242,  -242,   -34,  -242,   -33,   -54,   -48,  -242,  -242,  -242,
    -242,  -242,   -84,  -242,  -242,    47,  -145,  -242,   172,   -66,
    -242
  };

  const short
  parser::yydefgoto_[] =
  {
      -1,     1,    85,   169,     4,     2,    10,    11,     5,    13,
      31,    59,   219,   104,    32,    62,   117,   172,   197,   236,
      33,    63,   128,   129,   156,   130,   153,   131,   132,    71,
      34,    60,    35,    64,    36,   150,    55,    68,    99,    37,
      61,   105,   160,   116,    38,    47,   135,   161,   266,   267,
     273,   210,   263,   280,   144,   170,   233,   215,   245,   276,
     226,   227,   228,   229,   230,   252,   253,    87,    88,    89,
      90,    91,   246,   191,   141,   142,    39,    40,    41,   247,
     189
  };

  const short
  parser::yytable_[] =
  {
      26,   110,   -89,   112,   113,   149,    12,    29,   167,   261,
     103,    86,   265,     3,   183,    95,   152,   155,    -2,    43,
     178,    14,    44,   180,   193,   186,    29,   143,   187,   188,
      27,   279,   -15,   -15,   -15,   -15,    65,    66,    67,   173,
      58,    57,   262,     6,     7,     8,     9,    30,   181,    28,
      70,   218,   158,    92,    93,    94,    72,    96,   136,   137,
     138,   207,   208,   209,   100,   220,   106,   201,   202,   107,
     204,    97,    98,   101,   102,   243,   244,   224,   255,   111,
     166,   108,    15,    42,   192,   109,   221,   114,   118,   198,
     199,   115,   177,   127,   119,   179,   133,   134,   146,   147,
     211,   120,   140,   148,   -68,   157,   162,   165,   145,   163,
     182,   217,   168,   238,   185,   164,   260,   174,   127,   127,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
     176,   184,   195,   200,   213,   203,   159,    15,   206,   205,
     214,   127,   222,   175,   234,   212,   232,    69,   237,   285,
     127,   286,   249,   250,   242,   277,   239,   240,   254,   140,
      15,   248,   231,   259,   264,   262,   281,   269,    45,   127,
     127,   270,   127,   196,   275,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,   272,   278,   283,    46,   171,
     216,   251,   282,   274,   194,   159,    15,   258,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,   256,   257,
     271,   235,    56,   190,   284,   127,     0,     0,     0,   241,
     223,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,   224,   225,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    15,     0,     0,     0,     0,     0,
       0,   268,     0,     0,    15,   121,     0,     0,   122,   123,
     124,     0,     0,   125,   151,     0,   126,     0,   127,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,     0,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    15,   121,     0,     0,   122,   123,   124,     0,
       0,   125,    15,   121,   126,   154,   122,   123,   124,    48,
       0,   125,    15,     0,   126,    49,    50,     0,     0,     0,
      51,    52,    53,     0,     0,    54,     0,     0,   139,     0,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25
  };

  const short
  parser::yycheck_[] =
  {
       7,    85,    13,    87,    88,   119,     5,    22,   141,    21,
      71,    59,   253,     0,   159,    63,   125,   126,     0,    26,
     153,     4,    29,   156,   169,     4,    22,   111,     7,     8,
       4,   272,    23,    24,    25,    26,    46,    47,    48,   148,
      47,    12,    54,    23,    24,    25,    26,    62,   157,     4,
      57,   196,    63,    60,    61,    62,    12,    64,   106,   107,
     108,    42,    43,    44,    14,   198,    20,   176,   177,    20,
     179,    49,    50,    10,    11,    59,    60,    40,    41,    86,
     141,    20,     3,     4,   168,    18,   200,    12,    95,   173,
     174,    55,   153,   100,    12,   156,   103,    13,    12,    12,
     184,    53,   109,    14,    12,    14,    10,    14,   115,    21,
     158,   195,    13,   222,   162,    21,   249,    13,   125,   126,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      17,    13,    13,    12,    19,    13,   135,     3,    11,    16,
       8,   148,    17,   150,    13,    21,    17,    13,    13,   282,
     157,   284,   236,   237,    10,   269,    20,    20,    18,   166,
       3,    14,   210,     8,    10,    54,   275,    18,    29,   176,
     177,    21,   179,   172,    14,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    19,    21,    19,    29,   146,
     194,   239,   276,   266,   171,   194,     3,   245,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,   242,   242,
     264,   218,    40,   166,   280,   222,    -1,    -1,    -1,   226,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,     3,    -1,    -1,    -1,    -1,    -1,
      -1,   258,    -1,    -1,     3,     4,    -1,    -1,     7,     8,
       9,    -1,    -1,    12,    13,    -1,    15,    -1,   275,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    -1,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,     3,     4,    -1,    -1,     7,     8,     9,    -1,
      -1,    12,     3,     4,    15,    16,     7,     8,     9,    45,
      -1,    12,     3,    -1,    15,    51,    52,    -1,    -1,    -1,
      56,    57,    58,    -1,    -1,    61,    -1,    -1,    19,    -1,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50
  };

  const unsigned char
  parser::yystos_[] =
  {
       0,    65,    69,     0,    68,    72,    23,    24,    25,    26,
      70,    71,    67,    73,     4,     3,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    66,     4,     4,    22,
      62,    74,    78,    84,    94,    96,    98,   103,   108,   140,
     141,   142,     4,    66,    66,    91,    92,   109,    45,    51,
      52,    56,    57,    58,    61,   100,   142,    12,    66,    75,
      95,   104,    79,    85,    97,    46,    47,    48,   101,    13,
      66,    93,    12,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    66,   130,   131,   132,   133,
     134,   135,    66,    66,    66,   130,    66,    49,    50,   102,
      14,    10,    11,    76,    77,   105,    20,    20,    20,    18,
     136,    66,   136,   136,    12,    55,   107,    80,    66,    12,
      53,     4,     7,     8,     9,    12,    15,    66,    86,    87,
      89,    91,    92,    66,    13,   110,   130,   130,   130,    19,
      66,   138,   139,   136,   118,    66,    12,    12,    14,   118,
      99,    13,    86,    90,    16,    86,    88,    14,    63,    67,
     106,   111,    10,    21,    21,    14,    76,    77,    13,    67,
     119,   105,    81,    86,    13,    66,    17,    76,    77,    76,
      77,    86,   130,   140,    13,   130,     4,     7,     8,   144,
     139,   137,   136,   140,   110,    13,    67,    82,   136,   136,
      12,    86,    86,    13,    86,    16,    11,    42,    43,    44,
     115,   136,    21,    19,     8,   121,   106,   136,   140,    76,
      77,   118,    17,    27,    40,    41,   124,   125,   126,   127,
     128,   130,    17,   120,    13,    66,    83,    13,    86,    20,
      20,    66,    10,    59,    60,   122,   136,   143,    14,   136,
     136,   130,   129,   130,    18,    41,   126,   128,   130,     8,
      77,    21,    54,   116,    10,   116,   112,   113,    66,    18,
      21,   129,    19,   114,   119,    14,   123,   118,    21,   116,
     117,    86,   136,    19,   143,    77,    77
  };

  const unsigned char
  parser::yyr1_[] =
  {
       0,    64,    65,    66,    66,    66,    66,    66,    66,    66,
      66,    66,    66,    66,    67,    68,    69,    69,    70,    70,
      70,    70,    70,    71,    72,    72,    73,    73,    73,    73,
      73,    73,    73,    73,    75,    74,    76,    76,    77,    77,
      79,    80,    78,    81,    81,    82,    83,    83,    85,    84,
      86,    86,    86,    86,    86,    86,    86,    86,    87,    87,
      88,    88,    89,    89,    90,    90,    91,    91,    92,    93,
      93,    95,    94,    97,    96,    99,    98,   100,   100,   101,
     101,   101,   101,   102,   102,   102,   104,   103,   105,   106,
     107,   107,   109,   108,   110,   110,   111,   111,   112,   112,
     113,   114,   115,   115,   115,   115,   116,   117,   117,   118,
     118,   120,   119,   121,   121,   122,   122,   122,   123,   123,
     124,   124,   124,   124,   125,   125,   126,   126,   127,   127,
     128,   129,   129,   130,   130,   130,   131,   131,   131,   131,
     131,   131,   131,   131,   131,   132,   132,   132,   133,   134,
     135,   137,   136,   136,   136,   138,   138,   139,   139,   140,
     140,   141,   141,   142,   142,   143,   144,   144,   144
  };

  const signed char
  parser::yyr2_[] =
  {
       0,     2,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     0,     3,     0,     1,     3,
       3,     2,     2,     2,     2,     0,     2,     2,     2,     2,
       2,     2,     2,     2,     0,     6,     1,     1,     1,     0,
       0,     0,     9,     2,     0,     5,     3,     1,     0,     9,
       1,     1,     1,     1,     1,     1,     1,     1,     4,     2,
       3,     1,     4,     2,     5,     3,     5,     3,     1,     5,
       3,     0,     8,     0,     8,     0,    11,     1,     0,     1,
       1,     1,     0,     1,     1,     0,     0,    11,     0,     0,
       2,     0,     0,     9,     2,     0,    11,     3,     2,     1,
       0,     1,     1,     1,     1,     0,     4,     1,     0,     2,
       0,     0,    10,     2,     0,     1,     1,     0,     2,     0,
       1,     1,     1,     1,     3,     1,     4,     5,     3,     1,
       6,     1,     2,     2,     2,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     6,     4,
       4,     0,     5,     2,     0,     3,     1,     3,     1,     1,
       0,     2,     1,     2,     2,     1,     1,     1,     1
  };


#if YYDEBUG
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a yyntokens_, nonterminals.
  const char*
  const parser::yytname_[] =
  {
  "tok_eof", "error", "$undefined", "tok_identifier", "tok_literal",
  "tok_doctext", "tok_st_identifier", "tok_bool_constant",
  "tok_int_constant", "tok_dub_constant", "\",\"", "\";\"", "\"{\"",
  "\"}\"", "\"=\"", "\"[\"", "\"]\"", "\":\"", "\"(\"", "\")\"", "\"<\"",
  "\">\"", "\"@\"", "tok_include", "tok_namespace", "tok_cpp_include",
  "tok_hs_include", "tok_void", "tok_bool", "tok_byte", "tok_string",
  "tok_binary", "tok_i16", "tok_i32", "tok_i64", "tok_double", "tok_float",
  "tok_map", "tok_list", "tok_set", "tok_stream", "tok_sink", "tok_oneway",
  "tok_idempotent", "tok_readonly", "tok_safe", "tok_transient",
  "tok_stateful", "tok_permanent", "tok_server", "tok_client",
  "tok_typedef", "tok_struct", "tok_xception", "tok_throws", "tok_extends",
  "tok_service", "tok_enum", "tok_const", "tok_required", "tok_optional",
  "tok_union", "tok_interaction", "tok_performs", "$accept", "Program",
  "Identifier", "CaptureDocText", "DestroyDocText", "HeaderList", "Header",
  "Include", "DefinitionList", "Definition", "Typedef", "$@1",
  "CommaOrSemicolon", "CommaOrSemicolonOptional", "Enum", "$@2", "$@3",
  "EnumDefList", "EnumDef", "EnumValue", "Const", "$@4", "ConstValue",
  "ConstList", "ConstListContents", "ConstMap", "ConstMapContents",
  "ConstStruct", "ConstStructType", "ConstStructContents", "Struct", "$@5",
  "Union", "$@6", "Xception", "$@7", "ErrorSafety", "ErrorKind",
  "ErrorBlame", "Service", "$@8", "FlagArgs", "UnflagArgs", "Extends",
  "Interaction", "$@9", "FunctionList", "Function", "ParamList",
  "EmptyParamList", "Param", "FunctionQualifier", "Throws", "MaybeThrows",
  "FieldList", "Field", "$@10", "FieldIdentifier", "FieldRequiredness",
  "FieldValue", "FunctionType", "ResponseAndStreamReturnType",
  "StreamReturnType", "ResponseAndSinkReturnType", "SinkReturnType",
  "SinkFieldType", "FieldType", "BaseType", "ContainerType", "MapType",
  "SetType", "ListType", "TypeAnnotations", "$@11", "TypeAnnotationList",
  "TypeAnnotation", "StructuredAnnotations",
  "NonEmptyStructuredAnnotationList", "StructuredAnnotation",
  "FunctionAnnotations", "IntOrLiteral", YY_NULLPTR
  };


  const short
  parser::yyrline_[] =
  {
       0,   320,   320,   333,   338,   342,   346,   350,   354,   358,
     362,   366,   370,   374,   381,   392,   401,   406,   411,   415,
     422,   429,   436,   443,   463,   468,   473,   478,   483,   488,
     493,   498,   503,   508,   516,   515,   528,   530,   534,   539,
     545,   549,   544,   562,   590,   597,   609,   630,   644,   643,
     664,   670,   681,   687,   692,   720,   725,   730,   737,   742,
     750,   756,   765,   771,   779,   785,   794,   800,   809,   816,
     822,   832,   831,   846,   845,   861,   860,   906,   912,   917,
     923,   929,   935,   940,   946,   952,   959,   958,   973,   978,
     983,   998,  1005,  1004,  1035,  1042,  1048,  1087,  1104,  1114,
    1120,  1126,  1133,  1137,  1142,  1148,  1153,  1159,  1163,  1168,
    1175,  1182,  1181,  1215,  1251,  1257,  1268,  1280,  1285,  1295,
    1300,  1305,  1310,  1315,  1322,  1328,  1335,  1340,  1347,  1353,
    1360,  1368,  1372,  1378,  1383,  1388,  1395,  1400,  1405,  1410,
    1415,  1420,  1425,  1430,  1435,  1442,  1447,  1452,  1459,  1466,
    1473,  1481,  1480,  1489,  1495,  1501,  1508,  1518,  1523,  1530,
    1536,  1542,  1548,  1556,  1561,  1571,  1599,  1605,  1613
  };

  // Print the state stack on the debug stream.
  void
  parser::yystack_print_ ()
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  // Report on the debug stream that the rule \a yyrule is going to be reduced.
  void
  parser::yy_reduce_print_ (int yyrule)
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG


#line 120 "parse/thrifty.yy"
} } } } // apache::thrift::compiler::yy
#line 3796 "/builddir/build/BUILD/fbthrift-2021.04.12.00/thrift/compiler/thrifty.cc"

#line 1621 "parse/thrifty.yy"


/**
 * Method that will be called by the generated parser upon errors.
 */
void apache::thrift::compiler::yy::parser::error(std::string const& message) {
  driver.yyerror("%s", message.c_str());
}
